package rwd.abstractsyntax.spiderdiagram;
import java.util.Vector;
public class OrCompoundDiagram extends NaryCompoundDiagram {
	public OrCompoundDiagram(Vector diagrams, String name) {
		super(diagrams, name);
	}

	public void flatten() {
        //System.out.println("flattening in OrCompoundDiagram");
        //System.out.println("before flattening diagram is");
        //System.out.println(""+DiagramFileUser.toSaveStringWithNot(this));
		super.flatten();
		Vector children = new Vector();
		OrCompoundDiagram ocd;
		for (int i = 0; i < diagrams.size(); i++) {
			Diagram d = (Diagram) (diagrams.get(i));
			if (d instanceof OrCompoundDiagram) {
                //System.out.println("found an OrCompoundDiagram child");
				ocd = (OrCompoundDiagram) d;
				Vector grandchildren = ocd.getChildren();
				for (int j = 0; j < grandchildren.size(); j++) {
					children.add(grandchildren.get(j));
				}
			} else {
                //System.out.println("found a child to keep same");
				children.add(d);
			}
		}
        //System.out.println("after flattening diagram is");
        //System.out.println(""+DiagramFileUser.toSaveStringWithNot(this));
		this.setChildren(children);
	}
	public boolean equals(Diagram d) {
		if (!(d instanceof OrCompoundDiagram)) {
			return false;
		}
		OrCompoundDiagram otherd = (OrCompoundDiagram) (d);
		return super.equals(otherd);
	}
	public String toString() {
		String result = "" + getName() + "(";
		for (int i = 0; i < diagrams.size() - 1; i++) {
			result = result + diagrams.get(i) + " or ";
		}
		result = result + "" + diagrams.get(diagrams.size() - 1) + ")";
		return result;
	}
	public Diagram getClone() {
		Vector children = new Vector();
		for (int i = 0; i < diagrams.size(); i++) {
			children.add(((Diagram) (diagrams.get(i))).getClone());
		}
		return new OrCompoundDiagram(children, getName());
	}
}
