package rwd.concretesyntax.eulerdiagram;

import rwd.views.graph.BlockGraph;
import rwd.views.graph.BlockTree;

public class AEDVTree {
    AEDVZone top;

    public AEDVTree(BlockTree bt) {
        top = new AEDVZone(bt.top());
    }

    public AEDVZone top() {
        return top;
    }

    public void add(AEDView aedv, BlockGraph bg) {
        // navigate through the AEDVTree till you find
        // anAEDVComponent for that BlockGraph
        // and assign its aedv
        top.add(aedv, bg);
    }

    int countAEDViews() {
        return top.countAEDViews();
    }

    public boolean isMoreThanOneNode() {
        return countAEDViews() > 1;
    }

    public String toString() {
        return "tree with top \n" + top;
    }

    public AEDView getAEDView() {

        //System.out.println("need an AEDView for "+this);
        return top.getAEDView();
    }
}
