package rwd.concretesyntax.eulerdiagram;
import java.util.Vector;
import java.util.Iterator;
import java.util.TreeSet;

import rwd.abstractsyntax.eulerdiagram.Contour;
import rwd.abstractsyntax.eulerdiagram.Zone;
import rwd.views.graph.BlockGraph;
import rwd.views.graph.BlockNode;

public class AEDVZone {
	private BlockNode bn;
	private Vector aedvComponents;
	private Zone z;

	public AEDVZone(BlockNode bn) {
		this.bn = bn;
		////////////
		aedvComponents = new Vector();
		////////////
		Vector blockGraphs = bn.getChildren();
		Iterator childIt = blockGraphs.iterator();
		while (childIt.hasNext()) {
			BlockGraph bg = (BlockGraph) (childIt.next());
			aedvComponents.add(new AEDVComponent(this, bg));
		}
		Vector a=new Vector();
		TreeSet labels = bn.node().label1();
		Iterator i = labels.iterator();
		while (i.hasNext()) {
			Contour c = (Contour)i.next();
			String s = c.toString();
			a.add(Contour.getContour(s));
		}
		Vector a2=new Vector();
		labels = bn.node().label2();
		i = labels.iterator();
		while (i.hasNext()) {
			Contour c = (Contour)i.next();
			String s = c.toString();
			a2.add(Contour.getContour(s));
		}
		z = Zone.getZone(a,a2);
		// highly dubious allocation fo empty set
		// for excluding contours
		//System.out.println("zone "+z+"for "+bn);
	}

	public Zone getZone() {
		return z;
	}

	public Vector aedvComponents() {
		return aedvComponents;
	}

	public boolean add(
		AEDView aedv,
		BlockGraph bg) { // navigate through the AEDVTree till you find
		// anAEDVComponent for that BlockGraph
		// and assign its aedv
		Iterator childIt = aedvComponents.iterator();
		while (childIt.hasNext()) {
			AEDVComponent aedvc = (AEDVComponent) (childIt.next());
			if (aedvc.add(aedv, bg)) {
				return true;
			}
		}
		return false;
	}

	int countAEDViews() {
		int c = 0;
		for (int i = 0; i < aedvComponents.size(); i++) {
			c = c + ((AEDVComponent) aedvComponents.get(i)).countAEDViews();
		}
		return c;
	}

	public String toString() {
		String result = "for zone " + z;
		for (int i = 0; i < aedvComponents.size(); i++) {
			result = result + "\n" + aedvComponents.get(i);
		}
		result = result + "\n finished for zone " + z;
		return result;
	}

	public AEDView getAEDView() { // hack1 - get one component and return its AEDView
		//System.out.println("getting  aedv components");
		return ((AEDVComponent) aedvComponents.get(0)).aedview();
		// hack2 - get top components and return their AEDView
		//AEDView result = ((AEDVComponent)aedvComponents.get(0)).aedview();
		//result.makeRectangles(z,aedvComponents.size()-1);
		//for(int i=1; i<aedvComponents.size(); i++)
		//{ AEDVComponent aedvc =((AEDVComponent)aedvComponents.get(i));
		//  AEDView aedv = aedvc.aedview();
		//  result.add(aedv,z);
		//}
	}
}
