package rwd.concretesyntax.eulerdiagram;

import java.util.Vector;

public class DecorationSet 
	implements java.io.Serializable 
{   
    public DecorationSet() {
    }

	public DecorationSet(Vector boxes) {
		_boxes = boxes;
	}
    
    public Vector getBoxes() {
        return _boxes;
    }

	public void addBox(DecorationBox box) {
		if (!_boxes.contains(box))
			_boxes.add(box);
	}

	public void removeBox(DecorationBox box) {
		_boxes.remove(box);
	}
    
	public DecorationSet getClone() {
		DecorationSet res = new DecorationSet();
		for(int i=0; i<_boxes.size(); i++) {
			DecorationBox item = (DecorationBox)_boxes.get(i);
			res.addBox((DecorationBox)item.getClone());
		}
		return res;
	}

    public Object clone() {
    	return new DecorationSet((Vector)_boxes.clone()); 
    }
    
    // Local properties
    private Vector _boxes = new Vector();
}
