package rwd.deltas;

import java.util.List;
import java.util.Vector;

import rwd.concretesyntax.DiagramItem;
import rwd.concretesyntax.Observable;
import rwd.concretesyntax.Observer;

import uk.ac.kent.cs.kmf.util.ILog;
import uk.ac.kent.cs.kmf.util.OutputStreamLog;

/**
 * @author Octavian Patrascoiu
 *
 */
public abstract class Delta
	implements Observer
{

	// Evaluate
	public double evaluate() {
//		computeValue();
		return value;
	}

	// Update delta's value
	public void update(Observable item, Object arg) {
		if (item instanceof DiagramItem) {
			if (args.contains(item)) {
//				log.reportMessage("Update delta "+toString());
//				log.reportMessage("Old value:"+value);
				computeValue();
//				log.reportMessage("New value:"+value);
			}
		}
	}

	// Compute delta's value
	protected abstract void computeValue();
		
	//
	// Get the arguments (diagram items)
	//
	public List getArgs() {
		return args;
	}

	//
	// Local properties
	//
	protected double value = 0;
	protected List args = new Vector();
	protected ILog log = new OutputStreamLog(System.out);
}
