package rwd.deltas;

import rwd.concretesyntax.spiderdiagram.ConcreteSpiderFoot;
import uk.ac.kent.cs.kmf.util.ILog;
import uk.ac.kent.cs.kmf.util.OutputStreamLog;

/**
 * @author Octavian Patrascoiu
 *
 */
public class NodeNodeSeparationDelta 
	extends Delta
{
	// Constructor
	public NodeNodeSeparationDelta(ConcreteSpiderFoot foot1, ConcreteSpiderFoot foot2, ILog log) {
		this.log = log;
		args.add(foot1);
		args.add(foot2);
		foot1.addObserver(this);
		foot2.addObserver(this);	
		computeValue();
	}
	public NodeNodeSeparationDelta(ConcreteSpiderFoot foot1, ConcreteSpiderFoot foot2) {
		this(foot1, foot2, new OutputStreamLog(System.out));
	}
	protected void computeValue() {
		ConcreteSpiderFoot foot1 = (ConcreteSpiderFoot)args.get(0);
		ConcreteSpiderFoot foot2 = (ConcreteSpiderFoot)args.get(1);
		double x1 = foot1.getX();
		double y1 = foot1.getY();
		double x2 = foot2.getX();
		double y2 = foot2.getY();
		value = (x2-x1)*(x2-x1)+(y2-y1)*(y2-y1);
		if (value != 0)
			value = 1/value;
	}
	public String toString() {
		String res = this.getClass().getName().substring(11);
		res += "("+args.get(0).toString()+", "+args.get(1).toString()+")";
		return res;
	}
}
