package rwd.fopl.visitors;

import rwd.fopl.FoplVisitor;
import rwd.fopl.FoplVisitorImpl;
import rwd.ocl.constraintdiagram.ReadingTree;

/**
 * @author Octavian Patrascoiu
 *
 */
public class StringVisitor 
	extends FoplVisitorImpl
	implements FoplVisitor
{
	/** Visit class 'rwd.fopl.ast.Cuantifier' */
	public Object visit(rwd.fopl.ast.Cuantifier host, Object data) {
		String dom = (String)host.getDom().accept((FoplVisitor)this, data);
		String cond = (String)host.getCond().accept((FoplVisitor)this, data);
		return host.getKind()+host.getVar()+ReadingTree.BELONGS+dom+"("+cond+")";
	}
	/** Visit class 'rwd.fopl.ast.BinaryExpression' */
	public Object visit(rwd.fopl.ast.BinaryExpression host, Object data) {
		String left = (String)host.getLeft().accept((FoplVisitor)this, data);
		String right = (String)host.getRight().accept((FoplVisitor)this, data);
		return left+host.getOperator()+right;
	}
	/** Visit class 'rwd.fopl.ast.UnaryExpression' */
	public Object visit(rwd.fopl.ast.UnaryExpression host, Object data) {
		return host.getOperator()+host.getLeft().accept((FoplVisitor)this, data);
	}
	/** Visit class 'rwd.fopl.ast.Constant' */
	public Object visit(rwd.fopl.ast.Constant host, Object data) {
		return host.getValue();
	}
	/** Visit class 'rwd.fopl.ast.Type' */
	public Object visit(rwd.fopl.ast.Type host, Object data) {
		return host.getValue();
	}
}
