package rwd.gui;

import javax.swing.plaf.*;
import javax.swing.plaf.metal.*;
import java.awt.*;


/**
 * A Metal look and feel theme that simply makes all the fonts
 * larger and thus suitable for presenting the application
 * before a group of people.  Colours are unaffected.
 *
 * @creator Paul Mutton EDITED LATER BY J Flower, July 03
 * @author  $Author: op $
 * @version $Id: FontSizeTheme.java,v 1.7 2004/04/20 15:03:30 op Exp $
 */
public class FontSizeTheme extends DefaultMetalTheme {

    public FontUIResource getControlTextFont() {
        return controlFont;
    }
    
    public FontUIResource getMenuTextFont() {
        return controlFont;
    }

    public String getName() {
        return "MetalTheme";
    }

    public FontUIResource getSubTextFont() {
        return smallFont;
    }

    public FontUIResource getSystemTextFont() {
        return systemFont;
    }
    
    public FontUIResource getUserTextFont() {
        return userFont;
    }
    
    public FontUIResource getWindowTitleFont() {
        return controlFont;
    }

    void setFont(Font f)
    {
	    controlFont = new FontUIResource("Dialog", Font.PLAIN, f.getSize());
    	systemFont = new FontUIResource("Dialog", Font.PLAIN, f.getSize());
    	userFont = new FontUIResource("SansSerif", Font.PLAIN, f.getSize());
    	smallFont = new FontUIResource("Dialog", Font.PLAIN, f.getSize()-4);
    }

    private FontUIResource controlFont = new FontUIResource("Dialog", Font.PLAIN, 16);
    private FontUIResource systemFont = new FontUIResource("Dialog", Font.PLAIN, 16);
    private FontUIResource userFont = new FontUIResource("SansSerif", Font.PLAIN, 16);
    private FontUIResource smallFont = new FontUIResource("Dialog", Font.PLAIN, 14);

}
