package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import rwd.concretesyntax.spiderdiagram.ConcreteSpiderFoot;
import rwd.gui.editor.DiagramCanvas;
import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class DrawNewFootListener implements ActionListener {
	public DrawNewFootListener(EditorFrame frame, int type) {
		this.frame = frame;
		this.type = type;
	}
	
	public DrawNewFootListener(DiagramViewerInterface viewer, int type) {
		this.viewer = viewer;
		this.type = type;
	}

	public void actionPerformed(ActionEvent e) {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		DiagramCanvas dc = viewer.getDiagramCanvas();
		if (dc == null) return;
		int x = (int)dc.getCurrentX();
		int y = (int)dc.getCurrentY();
		addFoot(type, x, y);
	}

	public void addFoot(int type, int x, int y) {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		// Create an concrete spider foot
		ConcreteSpiderFoot foot = new ConcreteSpiderFoot("", type);
		foot.setLocation(x, y);
		viewer.add(foot);
				
		// Repaint image
		viewer.redrawImage();
	}
	
	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
	private int type;
}
