package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import rwd.concretesyntax.spiderdiagram.ConcreteSpiderFoot;
import rwd.concretesyntax.spiderdiagram.ConcreteSpiderLeg;
import rwd.gui.editor.DiagramCanvas;
import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class DrawNewLegListener implements ActionListener {
	public DrawNewLegListener(EditorFrame frame, int type) {
		this.frame = frame;
		this.type = type;
	}
	
	public DrawNewLegListener(DiagramViewerInterface viewer, int type) {
		this.viewer = viewer;
		this.type = type;
	}

	public void actionPerformed(ActionEvent e) {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		DiagramCanvas dc = viewer.getDiagramCanvas();
		if (dc == null) return;
		int x = (int)dc.getCurrentX();
		int y = (int)dc.getCurrentY();
		addLeg(type, x, y);
	}

	public void addLeg(int type, int x, int y) {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		// Create an concrete spider foot
		ConcreteSpiderFoot foot1 = new ConcreteSpiderFoot("", ConcreteSpiderFoot.NORMAL);
		foot1.setLocation(x, y);
		ConcreteSpiderFoot foot2 = new ConcreteSpiderFoot("", ConcreteSpiderFoot.NORMAL);
		foot2.setLocation(x+600, y);
		ConcreteSpiderLeg leg = new ConcreteSpiderLeg("", foot1, foot2, type);
		viewer.addWithoutHistory(foot1);
		viewer.addWithoutHistory(foot2);
		viewer.add(leg);
				
		// Repaint image
		viewer.redrawImage();
	}
	
	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
	private int type;
}
