package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class FormatBezierListener implements ActionListener {
	public FormatBezierListener(EditorFrame frame) {
		this.frame = frame;
	}
	
	public FormatBezierListener(DiagramViewerInterface viewer) {
		this.viewer = viewer;
	}

	public void actionPerformed(ActionEvent e) {
		smooth();
	}

	public void smooth() {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		if (viewer.isBezier() == true) {
			viewer.setBezier(false);
		} else {
			viewer.setBezier(true);
		}

		viewer.redrawImage();
	}

	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
}
