package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Collection;

import javax.swing.JOptionPane;

import rwd.concretesyntax.DiagramItem;
import rwd.gui.editor.EditorFrame;
import rwd.gui.editor.viewers.DiagramViewerInterface;

/**
 * @author Octavian Patrascoiu
 *
 */
public class FormatSetLabelListener implements ActionListener {
	public FormatSetLabelListener(EditorFrame frame) {
		this.frame = frame;
	}
	
	public FormatSetLabelListener(DiagramViewerInterface viewer) {
		this.viewer = viewer;
	}

	public void actionPerformed(ActionEvent e) {
		setLabel();
	}
	
	public void setLabel() {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;
		Collection selectedItems = viewer.getDiagramCanvas().getSelectedItems();
		if (selectedItems == null || selectedItems.size() != 1) return;
		DiagramItem selectedItem = (DiagramItem)selectedItems.iterator().next();
		if (selectedItem == null) return;
		String label =
			JOptionPane.showInputDialog(
				null,
				"Label",
				selectedItem.getLabel());
		if (label != null)
			viewer.setLabel(label);

		viewer.redrawImage();
	}

	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
}

