package rwd.gui.editor.listeners;

import java.awt.event.*;
import rwd.gui.editor.*;
import rwd.views.smoother.*;
import rwd.gui.editor.viewers.*;

/**
 *
 */
public class LayoutMotionListener
	implements ActionListener 
{
	public LayoutMotionListener(EditorFrame frame) {
		this.frame = frame;
	}
	
	public LayoutMotionListener(DiagramViewerInterface viewer) {
		this.viewer = viewer;
	}

	public void actionPerformed(ActionEvent e) {
		toggleMotion();
	}

	public void toggleMotion() {
		if (frame != null) viewer = frame.getCurrentViewer();
		if (viewer == null) return;

		if(viewer.getMotionFlag()) {
			DiagramMover dm = new DiagramMover(viewer);
			dm.stopMotion();
		} else {
			DiagramMover dm = new DiagramMover(viewer);
			dm.startMotion();
		}
	}

	// Local variables
	private EditorFrame frame;
	private DiagramViewerInterface viewer;
}
