package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JOptionPane;

import rwd.concretesyntax.ConcreteUnitaryDiagram;
import rwd.gui.editor.EditorFrame;
import rwd.ocl.constraintdiagram.ConstraintDiagram2Ocl;

/**
 * @author Octavian Patrascoiu
 *
 */
public class MapCd2PtcListener implements ActionListener {
	public MapCd2PtcListener(EditorFrame frame) {
		this.frame = frame;
	}

	public void actionPerformed(ActionEvent e) {
		String inputString =
			JOptionPane.showInputDialog(
				frame,
				"Please enter diagram name",
				"d");

		if (inputString != null) {
			// Get all the abstract unitary diagrams
			ConcreteUnitaryDiagram cud = frame.getCUDCalled(inputString);

			// Reset log
			frame.getLog().reset();

			// Create an OCL generator
			ConstraintDiagram2Ocl gen = new ConstraintDiagram2Ocl(cud, frame.getLog());

			// Generate the corresponding dependece diagrams
			String ptc  = gen.getPTCinFOPL(cud);

			// Print it out
			String message = "PTC for diagram '"+inputString+"'\n";
			message += ptc;
			frame.getLog().reportMessage(message);
		}
	}

	// Local variables
	protected EditorFrame frame;
}
