package rwd.gui.editor.listeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JFileChooser;

import rwd.gui.editor.EditorFrame;
import rwd.ocl.spiderdiagram.SpiderDiagram2OclDialog;
import rwd.ocl.spiderdiagram.SpiderDiagram2Ocl;

/**
 * @author Octavian Patrascoiu
 *
 */
public class MapSd2OclListener implements ActionListener {
	public MapSd2OclListener(EditorFrame frame) {
		this.frame = frame;
	}

	public void actionPerformed(ActionEvent e) {
		// Create a dialog to choose XMI and OCL files
		SpiderDiagram2OclDialog dialog = new SpiderDiagram2OclDialog(frame, "SD2OCL", frame.getLog());
		int returnVal = dialog.showOpenDialog(frame);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			String inputString = dialog.getLogicExp();
			if (inputString != null) {
				// Get all the abstract unitary diagrams
				List cds = frame.getConcreteDiagrams(frame.getDesktopPane());

				// Reset log
				frame.getLog().reset();

				// Create an OCL generator
				SpiderDiagram2Ocl gen = new SpiderDiagram2Ocl(cds, frame.getLog());

				// Generate the corresponding OCL
				String oclStr = gen.makeOCL(inputString);

				// Print it out
				frame.getLog().reportMessage(oclStr);
			}
		}
	}

	// Local variables
	protected EditorFrame frame;
}
