package rwd.gui.editor.writers;

import java.io.File;
import java.io.IOException;

import uk.ac.kent.cs.kmf.util.ILog;
import uk.ac.kent.cs.kmf.util.OutputStreamLog;

/**
 * @author Octavian Patrascoiu
 *
 */
class Jpeg2Ps {
	public Jpeg2Ps(File jpegFile, File psFile, ILog log) {
		this.jpegFile = jpegFile;
		this.psFile = psFile;
		this.log = log;
	}
	
	public void convert() {
		// Prepare arguments
		String jpegFileName = jpegFile.getAbsolutePath();
		String psFileName = psFile.getAbsolutePath();
		String command = exe+" -o \""+psFileName+"\" \""+jpegFileName+"\"";
		try {
			// Launch the exe
			Process process = Runtime.getRuntime().exec(command);
			try {
				process.waitFor();
				process.exitValue();
			} catch (InterruptedException ie) {
				throw new IOException("InterruptedException while making eps: " + ie.getMessage());
			}
			log.reportMessage("EPS file '"+psFileName+"' created.");
			if (!psFile.exists()) {
				System.out.println("No");
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	// Local properties
	File jpegFile;
	File psFile;
	ILog log;

	protected String exe = "jpeg2ps.exe";

	public static void main(String args[]) {
		File jpgFile = new File("C:/Documents and Settings/op.UKC/My Documents/cd1.jpg");
		File psFile = new File("C:/Documents and Settings/op.UKC/My Documents/cd1.eps");
		Jpeg2Ps jpg2ps = new Jpeg2Ps(jpgFile, psFile, new OutputStreamLog(System.out));
		jpg2ps.convert();
	}	
}
