package rwd.metrics;

import java.awt.Polygon;
import java.util.Iterator;
import java.util.Set;

import rwd.abstractsyntax.eulerdiagram.Contour;
import rwd.concretesyntax.ConcreteUnitaryDiagram;
import rwd.concretesyntax.eulerdiagram.ConcreteContour;
import rwd.concretesyntax.eulerdiagram.DecorationBox;


public class ContourClosenessPointPoint
	extends EulerMetric 
{
	//NEEDS WORK!! Seems to mess up the diagram in spiky ways
	// also observed strange tendency to drift to the right?
	public ContourClosenessPointPoint(ConcreteUnitaryDiagram cud, double weighting) {
		super(cud, weighting);
	}

	protected double giveScore() {
		Set contourPolys = cud.getConcreteContours();

		if (contourPolys.size() < 2) {
			return (0.0);
		}

		double total = 0.0;
		double sumOfAllDistances = 0.0;
        
        Iterator i = contourPolys.iterator();
        while(i.hasNext()){
			ConcreteContour cp1 = (ConcreteContour)i.next();
			Polygon p1 = cp1.getPolygon();
			int[] xs1 = p1.xpoints;
			int[] ys1 = p1.ypoints;
			int numPts1 = p1.npoints;

            Iterator j = contourPolys.iterator();
            if(j.hasNext()){
                ConcreteContour cp2 = (ConcreteContour)j.next();
                while(cp2!=cp1){
                    cp2 = (ConcreteContour)j.next();
                }
            }
            while(j.hasNext()){
				ConcreteContour cp2 = (ConcreteContour)j.next();

				Polygon p2 = cp2.getPolygon();
				double pairTotal = 0.0;

				// get closest separation value
				//double closest = Double.MAX_VALUE;
				int[] xs2 = p2.xpoints;
				int[] ys2 = p2.ypoints;
				int numPts2 = p2.npoints;
				double x, y, x2, y2;
				// for each point on the first polygon....
				for (int pi = 0; pi <= numPts1 - 1; pi++) {
					x = xs1[pi];
					y = ys1[pi];
					// (x,y) is a vertex on the first polygon
					// for each point of the second polygon...
					for (int pj = 0;pj <= numPts2 - 1; pj++) { // loop n-1 times
						x2 = xs2[pj];
						y2 = ys2[pj];
						double val = ((x-x2)*(x-x2)+(y-y2)*(y-y2));
						//System.out.println("points distance is "+val);
						//if (val < closest && val != 0.0)
						//{ closest = val; }
						if (val != 0)
							pairTotal += 1 / val;
						sumOfAllDistances += val;
					}
				}
				//double recip = 1/(closest*closest);
				if (numPts1*numPts2 != 0)
					pairTotal = pairTotal / (numPts1 * numPts2);

				//if(total < recip){ total = recip; }
				total += pairTotal;
			}
		}

		//total = total*DiagramAreaMetric.getDiagramArea(polys);
		total = total * sumOfAllDistances;
		//System.out.println("ContourClosenessMetric: "+total);
		return total;
	}
	public static void main(String[] args) { //build PolygonSet with null zones is OK
		Polygon p1 =
			new Polygon(
				new int[] { 0, 20, 20, 0 },
				new int[] { 0, 0, 20, 20 },
				4);
		Polygon p2 =
			new Polygon(
				new int[] { 5, 35, 30, 10 },
				new int[] { 5, 10, 30, 25 },
				4);
		ConcreteContour cp1 = new ConcreteContour(Contour.getContour("a"), p1);
		ConcreteContour cp2 = new ConcreteContour(Contour.getContour("b"), p2);
        ConcreteUnitaryDiagram cud = new ConcreteUnitaryDiagram(
        new DecorationBox("box", "", new Polygon(new int[]{0,50,50,0},new int[]{0,0,50,50},4)));
        cud.addConcreteContour(cp1);
        cud.addConcreteContour(cp2);
		/**/
		System.out.println(
			"" + new ContourClosenessPointPoint(cud, 1.0).giveScore());
		;
		////////////////
		p1 =
			new Polygon(
				new int[] { 0, 200, 200, 0 },
				new int[] { 0, 0, 200, 200 },
				4);
		p2 =
			new Polygon(
				new int[] { 50, 350, 300, 100 },
				new int[] { 50, 100, 300, 250 },
				4);
		cp1 = new ConcreteContour(Contour.getContour("a"), p1);
		cp2 = new ConcreteContour(Contour.getContour("b"), p2);
        cud = new ConcreteUnitaryDiagram(
        new DecorationBox("box", "", new Polygon(new int[]{0,400,400,0},new int[]{0,0,400,400},4)));
        cud.addConcreteContour(cp1);
        cud.addConcreteContour(cp2);
		/**/
		System.out.println(
			"" + new ContourClosenessPointPoint(cud, 1.0).giveScore());
		;
	}

}
