package rwd.metrics.quality.viewers;

import rwd.concretesyntax.ConcreteUnitaryDiagram;
import rwd.metrics.quality.BrowserLauncher;
import rwd.metrics.quality.HtmlGenerator;
import rwd.metrics.quality.KiviatGenerator;
import rwd.metrics.quality.PieGenerator;
import rwd.metrics.quality.QualityModel;
import uk.ac.kent.cs.kmf.util.ILog;
import uk.ac.kent.cs.kmf.util.OutputStreamLog;

/**
 * @author Octavian Patrascoiu
 *
 */
public class Viewer 
{
	/** 
	 * Constructor
	 * obj can be either a model element or
	 * a list of model elements 
	 * */
	public Viewer(QualityModel qualityModel, ConcreteUnitaryDiagram cud, int kind) {
		this.qualityModel = qualityModel;
		this.obj = cud;
		this.kind = kind;
	}

	public void view() {
		// Generate html
		ILog log = new OutputStreamLog(System.out);
		if (kind == KIVIAT) {
			HtmlGenerator gen = new KiviatGenerator(qualityModel, htmlFile, log);
			gen.generate(obj);
		} else {
			HtmlGenerator gen = new PieGenerator(qualityModel, htmlFile, log);
			gen.generate(obj);
		}
		try {
			BrowserLauncher.openURL(htmlFile);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	//
	// Local properties
	//
	public static int KIVIAT = 1;
	public static int PIE = 2;
	protected QualityModel qualityModel;
	protected int kind = KIVIAT;
	protected Object obj;
	protected String htmlFile = "Quality.html";
}
