package rwd.ocl.constraintdiagram;

import java.util.*;

/**
 * @author Octavian Patrascoiu
 *
 */
public class Graph {
	public class Pair {
		public Pair(Object first, Object second) {
			this.first = first;
			this.second = second;
		}
		public Object first;
		public Object second;
	}
	public Graph(List nodes) {
		this.nodes = nodes;
		this.n = nodes.size();
		this.edges = new boolean[n][n];
	}
	
	public void addPair(Object node1, Object node2) {
		add(node1, node2);
	}
	protected void add(Object node1, Object node2) {
		int i = nodes.indexOf(node1);
		int j = nodes.indexOf(node2);
		edges[i][j] = true;
	}
	
	public boolean isEdge(Object node1, Object node2) {
		int i = nodes.indexOf(node1);
		int j = nodes.indexOf(node2);
		return edges[i][j];
	}
		
	public List getNodes() {
		return nodes;
	}	
	
	public List getEdges() {
		List res = new Vector();
		for(int i=0; i<n; i++) {
			Object n1 = nodes.get(i);
			for(int j=0; j<n; j++) {
				Object n2 = nodes.get(j);
				if (edges[i][j])
					res.add(new Pair(n1, n2));
			}
		}
		return res;
	}
	
	public List getNodes(Object node) {
		int i = nodes.indexOf(node);
		List res = new Vector();
		for(int j=0; j<n; j++) {
			if (edges[i][j]) {
				res.add(nodes.get(j));
			}
		}
		return res;
	}	

	public Graph closure() {
		Graph res = (Graph)this.clone();
		List nodes = res.getNodes();
		for(int j=0; j<n; j++) {
			for(int i=0; i<n; i++) {
				for(int k=0; k<n; k++) {
					if (edges[i][j] && edges[j][k]) {
						edges[i][k] = true;
					}
				}
			}
		}
		return res;
	}
	
	public Object clone() {
		List nodes = new Vector();
		nodes.addAll(getNodes());
		Graph res = new Graph(nodes);
		for(int i=0; i<n; i++) 
			for(int j=0; j<n; j++)
				res.edges[i][j] = edges[i][j]; 		
		return res;
	}
		
	// Local properties
	protected List nodes = new Vector();
	protected int n = nodes.size();
	protected boolean edges[][];
}
