package rwd.ocl.constraintdiagram;

/**
 * A stream of input characters for parsing.
 * End-of-stream is represented by the value -1.
 * 
 * @author Octavian Patrascoiu, rnb
 * 
 * @version 28.7.05   09:34
 *
 */
//
// Input tape
//
interface InputTape {
	public int nextChar();
}

class StringInputTape 
	implements InputTape
{
	//
	// Local properties
	//
	protected String input = "";  // input string
	protected int i = 0;          // offset of next character of string to be read

	// constructor
	// -----------
	
	/*
	 * test: once thru
	 */
	public StringInputTape(String input) {
		if (input == null) input = "";
		this.input = input;
		this.i = 0;
	}
	
	// attributes
	// ----------
	
	/*
	 * test: 
	 *   not at end of tape
	 *   at end of tape
	 */
	public int nextChar() {
		if (i >= input.length()) {
			return -1;
		} else {
			char ch = input.charAt(i);
			i++;
			return ch;
		}
	}
	
	/*
	// test program
    // ------------

    private static void pr(String s) {
      System.out.println(s);
    }

    private static void hd(String s) {
      System.out.println("\n" + s + "\n");
    }

    private static void pg() {
      try {
        int i;
        System.out.print("next page? (CR)");
        do i = System.in.read(); while (i != '\n');
        System.out.println();
      }
      catch (Exception e) {System.out.println("raised exception : " + e);}
    }

    public static void main(String args[]) throws Exception {
    	
    	hd("test of nextChar");
    	InputTape it = new StringInputTape("fred");
    	for (int i = 0; i < 6; i++) {
    		int c = it.nextChar();
    		pr("it.nextChar()=" + (char) c + "(" + c + ")");
    	}
    }
	*/
}
