package rwd.ocl.spiderdiagram;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

import uk.ac.kent.cs.kmf.util.ILog;

/**
 * @author Octavian Patrascoiu
 *
 */
public class SpiderDiagram2OclDialog
	extends JDialog
{
	public SpiderDiagram2OclDialog(JFrame parent, String title, ILog log) {
		super(parent, title);	
		getContentPane().setLayout(new GridBagLayout());
		this.log = log;
		
		//
        //--- Create and fill PROJECT panel
        //
		generalPanel = new JPanel(new GridBagLayout());
	    //--- Give the panel a border gap of 5 pixels ---
	    generalPanel.setBorder(new EmptyBorder(new Insets(10, 10, 10, 10)));
	    //--- Get the constraints ---
	    GridBagConstraints c = new GridBagConstraints();
	    //--- Add space around all components to avoid clutter ---
	    c.insets = new Insets(2, 2, 2, 2);
	    c.ipadx = 5;
	    c.ipady = 5;
	    c.weightx = 0.0;
	    c.weighty = 0.0;
		//--- Initialize common variables ---
		int line = 0;
		int column = 0;
    	EmptyBorder border = new EmptyBorder(new Insets(0, 0, 0, 10));
    	Dimension buttonSize = new Dimension(100, 25);
    	int fieldSize = 10;
		JLabel label;
		JButton button;

    	//--- Logical expression label ---
		label = new JLabel("Logical expression");
	    label.setBorder(border);
	    c.gridx = column;
	    c.gridy = line;
	    c.anchor = GridBagConstraints.WEST;
	    generalPanel.add(label, c);
        //--- Logical expression area ---
        logicField = new JTextField(fieldSize);
        logicField.setText("d");
	    c.gridx = column+1;
	    c.gridy = line;
	    generalPanel.add(logicField, c);
	    line++;

		//
        //--- Create and fill CONFIRM panel ---
        //
        JPanel confirmPanel = new JPanel(new GridBagLayout());
        //--- OK button ---
		JButton okButton = new JButton("OK");
		okButton.setPreferredSize(buttonSize);
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okAction(evt);
            }
        });
	    c.gridx = 0;
	    c.gridy = 0;
		confirmPanel.add(okButton);
        //--- Cancel button ---
		JButton cancelButton = new JButton("Cancel");
		cancelButton.setPreferredSize(buttonSize);
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelAction(evt);
            }
        });
	    c.gridx = 0;
	    c.gridy = 1;
		confirmPanel.add(cancelButton);

	    //--- Add TAB panel to MAIN panel ---
	    c.gridx = 0;
	    c.gridy = 0;
		getContentPane().add(generalPanel, c);

		//--- Add CONFIRM to MAIN panel ---		
	    c.gridx = 0;
	    c.gridy = 1;
	    c.anchor = GridBagConstraints.CENTER;
	    getContentPane().add(confirmPanel, c);
    		
        // Put frame in the middle of the screen
        pack();
        Dimension screen = getToolkit().getScreenSize();
        int width  = this.getSize().width+20;
        int height = this.getSize().height+20;
        int left = (screen.width - width)/2;
        int top = (screen.height - height)/2;
        setBounds(left, top, width, height);
	}

	//--- OK action ---
	protected int returnVal = JFileChooser.CANCEL_OPTION;
    protected void okAction(java.awt.event.ActionEvent evt) {
    	returnVal = JFileChooser.APPROVE_OPTION;
    	String input = getLogicExp();
		if (input != null && input.length() != 0)  	
			dispose();
    }

	//--- Cancel action ---
    protected void cancelAction(java.awt.event.ActionEvent evt) {
		returnVal = JFileChooser.CANCEL_OPTION;   	
    	dispose();
    }

	//--- Get XMI file name ----
	public int showOpenDialog(JFrame parent) {
		this.setModal(true);
		show();
		return returnVal;
	}
	
	//--- Get the logical expression ----
	public String getLogicExp() {
		return logicField.getText();
	}
	
	protected JPanel generalPanel;
	protected JTextField logicField;

	protected ILog log;
}
