package rwd.rules;

import java.util.Vector;

import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.autoproof.*;
import rwd.abstractsyntax.spiderdiagram.*;
import rwd.abstractsyntax.eulerdiagram.*;

/**
 * @author jaf28
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ContradictionAssessor {
	public static boolean isInContradiction(Diagram d1, Diagram d2) { 	
		if(d1 instanceof FalseDiagram || d2 instanceof FalseDiagram) { 
			return true; 
		}
		
		d1 = ContourSetEqualiser.makeContourSetsEqual(d1,d2).getLastDiagram();
		d2 = ContourSetEqualiser.makeContourSetsEqual(d2,d1).getLastDiagram();
		d1 = ZoneEqualiser.makeZonesEqual(d1,d2).getLastDiagram();
		d2 = ZoneEqualiser.makeZonesEqual(d2,d1).getLastDiagram();
		Vector parts = new Vector();
		parts.add(d1);
		parts.add(d2);
		Diagram d1AndD2 = new AndCompoundDiagram(parts,"ad");
		d1AndD2 = SpiderSplitter.splitAllSpiders(d1AndD2).getLastDiagram();
		d1AndD2 = MakerOfDisNF.turnToDisjNF(d1AndD2).getLastDiagram();
		d1AndD2 = Combiner.combineWherePossible(d1AndD2).getLastDiagram();		
		
		//System.out.println("d1Andd2 is "+DiagramFileUser.toSaveString(d1AndD2));
		// could be false or false or...
		if(d1AndD2 instanceof UnitaryDiagram) {
			return d1AndD2 instanceof FalseDiagram; 
		} else if (d1AndD2 instanceof FalseDiagram) {
			return true; 
		} else { 
			OrCompoundDiagram ocd = (OrCompoundDiagram)d1AndD2;
			Vector parts2 = ocd.getChildren();
			for(int i=0; i<parts2.size(); i++) {
				if(!(parts2.get(i) instanceof FalseDiagram)) { 
					return false; 
				}
			}
			return true;
		}
	}
	
	public static void main(String args[])
	{
		
		Vector zones1 = new Vector();
		zones1.add(Zone.getZoneFor("","a"));
		zones1.add(Zone.getZoneFor("a","a"));
		Vector szones1 = new Vector();
		szones1.add(Zone.getZoneFor("a","a"));
		Vector hab1 = new Vector();
		hab1.add(Zone.getZoneFor("a","a"));
		Spider s1 = new Spider(hab1);

		Vector zones2 = new Vector();
		zones2.add(Zone.getZoneFor("","ab"));
		zones2.add(Zone.getZoneFor("a","ab"));
		zones2.add(Zone.getZoneFor("b","ab"));
		Vector szones2 = new Vector();
		Vector hab2 = new Vector();
		hab2.add(Zone.getZoneFor("a","ab"));
		Spider s2 = new Spider(hab2);
		Vector hab3 = new Vector();
		hab3.add(Zone.getZoneFor("","ab"));
		Spider s3 = new Spider(hab3);
		
		UnitaryDiagram d1 = new UnitaryDiagram(zones1, "ud1");
		d1.setShadedZones(szones1);
		d1.addSpider(s1);

		UnitaryDiagram d2 = new UnitaryDiagram(zones2, "ud1");
		d2.setShadedZones(szones2);
		d2.addSpider(s2);
		d2.addSpider(s3);
		
		System.out.println("d1 is "+DiagramFileUser.toSaveString(d1));
		System.out.println("d2 is "+DiagramFileUser.toSaveString(d2));
		System.out.println("contradicts? : "+isInContradiction(d1,d2));
	}
}
