package rwd.rules.autoproof;
import rwd.abstractsyntax.spiderdiagram.*;
import rwd.abstractsyntax.eulerdiagram.Contour;
import rwd.abstractsyntax.eulerdiagram.Zone;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.CompoundDiagram;
import java.util.Vector;
import java.util.Iterator;
//import java.util.Iterator;

import rwd.rules.Proof;
import rwd.rules.Rule;
//import rwd.rules.application.DummyRuleApplicationSpec;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.application.RuleAppliesToDiDiAL;
import rwd.rules.application.RuleAppliesWithString;
import rwd.rules.inputspec.RuleAddContour;
import rwd.rules.application.RuleAppliesToContour;
import rwd.rules.choicespec.RuleSplitSpider;
import rwd.rules.application.RuleAppliesToSpiderAndRegion;
import rwd.abstractsyntax.spiderdiagram.OrCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.rules.application.RuleAppliesToDandDandD;
import rwd.rules.choicespec.RuleJoinSpiders;
import rwd.rules.choicespec.RuleDistributeAndOverOr;
import rwd.rules.application.RuleAppliesToDiagramAndDiagrams;
import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
import rwd.rules.choicespec.RuleDistributeMergeAnds;
import rwd.rules.nospec.SimpleCombiningRule;
import rwd.rules.application.RuleAppliesToJustADiagram;
import rwd.rules.nospec.AndIdempotentRule;
import rwd.rules.application.RuleAppliesToZone;
import rwd.rules.choicespec.RuleUnshadeZone;
import rwd.rules.choicespec.RuleDeleteShadedZone;
import rwd.abstractsyntax.spiderdiagram.Spider;
import rwd.rules.application.RuleAppliesToSpider;
import rwd.rules.choicespec.RuleDeleteSpider;
import rwd.rules.application.RuleAppliesToDiagramAndDiagram;
import rwd.rules.inputspec.RuleFalseImpliesAnything;
import rwd.rules.choicespec.FalseWithAndRule;
import rwd.rules.choicespec.InvertRemoveNotRule;
import rwd.rules.choicespec.InvertShatterSpidersRule;
import rwd.rules.choicespec.InvertToDNFRule;
import rwd.rules.choicespec.RuleDeleteContourSimple;
import rwd.rules.choicespec.RuleExcludedMiddle;
import rwd.rules.choicespec.RulePullNotsBackFromLeaves;
import rwd.rules.choicespec.RuleReverseExcludedMiddle;
import rwd.rules.choicespec.FalseWithOrRule;
import rwd.rules.nospec.RulePToPorF;
import rwd.rules.choicespec.RuleIntroduceShadedZone;
import rwd.rules.choicespec.RuleReverseOrIdempotent;
import rwd.rules.inputspec.*;
import rwd.rules.nospec.InsertNotNotRule;
//import rwd.rules.nospec.OrIdempotentRule;
import rwd.rules.nospec.NotFalseIsTrueRule;
import rwd.rules.nospec.NotTrueIsFalseRule;
import rwd.rules.nospec.OrIdempotentRule;
import rwd.rules.nospec.RemoveNotNotRule;
import rwd.rules.nospec.RemoveNotRuleComplex;
import rwd.rules.nospec.RulePushNotsToLeaves;
import rwd.rules.nospec.ShatterSpidersRule;
import rwd.rules.nospec.ToDNFRule;

/**
 * @author jaf28
 *
 */
public class ProofInverter {

    public static Proof invertProof(Proof p1) {
        Proof result = new Proof(p1.getLastDiagram());
        p1.goToStart();
        while (p1.goToNextStep()) {
        }
        //p1 is at end
        stepLoop : while (p1.goBackAStep()) {
            Diagram before = p1.getCurrentDiagram();
            Rule r = p1.getImminentRule();
            //System.out.println("about to invert rule "+r);
            RuleApplicationSpec ras = p1.getImminentRuleApplicationSpec();
            Diagram partBefore = ras.d;
            Diagram after = p1.getNextDiagram();
            int[] coords = before.getCoords(partBefore);
            if (coords == null) { /**/
                System.out.println("proof includes step on part not present1");
                System.out.print("rule " + r + " on ");
                System.out.print(
                    "part before: "
                        + partBefore.hashCode()
                        + "\n"
                        + DiagramFileUser.toSaveString(partBefore));
                System.out.println(
                    "within whole: "
                        + before.hashCode()
                        + "\n"
                        + DiagramFileUser.toSaveString(before));
                new IllegalArgumentException().printStackTrace();
                System.exit(0);
            }
            ////////////////////////////////////////////////////////////////
            ////////////////////////////////INVERT "ADD CONTOUR"
            try {
                RuleAddContour rac = (RuleAddContour) r;
                RuleAppliesWithString raws = (RuleAppliesWithString) ras;
                //
                // raws specifies a "part" in before to which to apply the rwd.rules rac
                // we need to identify the "part" in after - in order to undo the move
                //
                Diagram partAfter = after.getPartAt(coords);
                //
                Contour c = Contour.getContour(raws.s);
                Rule rdc = RuleDeleteContourSimple.getRule();
                RuleAppliesToContour racSpec =
                    new RuleAppliesToContour(partAfter, c);
                //
                //System.out.println("check :");
                //System.out.println("after is :"+after.toSaveString());
                //System.out.println("spec is :"+racSpec);
                //System.out.println("rdc.applyRuleToPart(after,racSpec) is :"
                //                  +rdc.applyRuleToPart(after,racSpec).toSaveString());
                //System.out.println("before is :"+before.toSaveString());
                if (rdc.applyRuleToPart(after, racSpec).equals(before)) {
                    result.addStepAtEnd(rdc, racSpec, before);
                } else {
                    throw new IllegalArgumentException();
                }
                // result.addStepAtEnd(x,y,z)
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            ////////////////////////////////////////////////////////////////
            ////////////////////////////////INVERT "DELETE CONTOUR SIMPLE"
            try {
                RuleDeleteContourSimple rdcs = (RuleDeleteContourSimple) r;
                RuleAppliesToContour rasc = (RuleAppliesToContour) ras;
                //
                // rac specifies a "part" in before to which to apply the rwd.rules rac
                // we need to identify the "part" in after - in order to undo the move
                //
                Diagram partAfter = after.getPartAt(coords);
                //
                Rule rac = RuleAddContour.getRule();
                //
                //System.out.println("check :");
                //System.out.println("after is :"+after.toSaveString());
                //System.out.println("spec is :"+racSpec);
                //System.out.println("rdc.applyRuleToPart(after,racSpec) is :"
                //                  +rdc.applyRuleToPart(after,racSpec).toSaveString());
                //System.out.println("before is :"+before.toSaveString());
                if (rac.applyRuleToPart(after, rasc).equals(before)) {
                    result.addStepAtEnd(rac, rasc, before);
                } else {
                    throw new IllegalArgumentException();
                }
                // result.addStepAtEnd(x,y,z)
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            ////////////////////////////////////////////////////////////////
            ////////////////////////////////INVERT "ADD SHADED ZONE"
            try {
                RuleIntroduceShadedZone risz = (RuleIntroduceShadedZone) r;
                RuleAppliesToZone raz = (RuleAppliesToZone) ras;
                //
                // raz specifies a "part" in before to which to apply the rwd.rules rac
                // we need to identify the "part" in after - in order to undo the move
                //
                Diagram partAfter = after.getPartAt(coords);
                //
                Zone z = raz.z;
                Rule rdsz = RuleDeleteShadedZone.getRule();
                raz = new RuleAppliesToZone(partAfter, z);
                //
                //System.out.println("check :");
                //System.out.println("after is :"+after.toDebugString());
                //System.out.println("spec is :"+racSpec);
                //System.out.println("rdc.applyRuleToPart(after,racSpec) is :"
                //                  +rdc.applyRuleToPart(after,racSpec).toDebugString());
                //System.out.println("before is :"+before.toDebugString());
                if (rdsz.applyRuleToPart(after, raz).equals(before)) {
                    result.addStepAtEnd(rdsz, raz, before);
                } else {
                    throw new IllegalArgumentException();
                }
                // result.addStepAtEnd(x,y,z)
                continue stepLoop;
            } catch (ClassCastException e) {
            }

            ////////////////////////////////////////////////////////////////
            ////////////////////////////////INVERT "SPLIT SPIDER"
            try {
                RuleSplitSpider rss = (RuleSplitSpider) r;
                RuleAppliesToSpiderAndRegion rasr =
                    (RuleAppliesToSpiderAndRegion) ras;
                //
                // rasr specifies a spider and a subregion of its habitat
                // we need to specify d=an or-diagram and ud1=unitary part
                // and ud2 = unitary part where ud1 and ud2 differ in 1 disjoint spider
                // find out whether the parent of partBefore in before
                // was an or-diagram
                Diagram parent = before.getParentOf(partBefore);
                // if it was, then part for reverse must be that with partAfter
                // substituted
                if (parent != null && (parent instanceof OrCompoundDiagram)) {
                    OrCompoundDiagram ocd = (OrCompoundDiagram) parent;
                    // if it was, then part for reverse must be that with partAfter
                    // substituted
                    int[] preParentCoords = before.getCoords(ocd);
                    CompoundDiagram parentAfter =
                        (CompoundDiagram) after.getPartAt(preParentCoords);
                    // two children of parentAfter are the outcome of the split
                    // find out what these children are like
                    rasr.d = partBefore;
                    Vector twoChildren =
                        ((CompoundDiagram) rss.applyRule(rasr)).getChildren();
                    boolean haveMatchedFirst = false;
                    Diagram ud1 = (Diagram) twoChildren.get(0);
                    Diagram child1 = null;
                    boolean haveMatchedSecond = false;
                    Diagram ud2 = (Diagram) twoChildren.get(1);
                    Diagram child2 = null;
                    childSearch : for (
                        int i = 0; i < parentAfter.getChildren().size(); i++) {
                        Diagram child =
                            (Diagram) parentAfter.getChildren().get(i);
                        if (child.equals(ud1) && !haveMatchedFirst) {
                            child1 = child;
                            haveMatchedFirst = true;
                            continue childSearch;
                        }
                        if (child.equals(ud2) && !haveMatchedSecond) {
                            child2 = child;
                            haveMatchedSecond = true;
                        }
                    }
                    //System.out.println("child1 is "+child1);
                    //System.out.println("child2 is "+child2);
                    RuleApplicationSpec rddd =
                        new RuleAppliesToDandDandD(parentAfter, child1, child2);
                    Rule rjs = RuleJoinSpiders.getRule();
                    //System.out.println("joining spiders");
                    //System.out.println("part is "+parentAfter.toSaveString());
                    //System.out.println("whole is "+after.toSaveString());
                    //System.out.println("applyRuleToPart(after,rddd) is "+
                    //                rjs.applyRuleToPart(after,rddd).toSaveString());
                    if (rjs.applyRuleToPart(after, rddd).equals(before)) {
                        result.addStepAtEnd(rjs, rddd, before);
                    } else {
                        throw new IllegalArgumentException();
                    }
                    //
                    continue stepLoop;
                }
                // here we know that the parent of the pre-split part
                // was null or and-compound
                // so the post-split diagram at same coords is an or-diagram
                Diagram parentAfter = after.getPartAt(coords);
                Diagram ud1 =
                    (Diagram) ((CompoundDiagram) parentAfter)
                        .getChildren()
                        .get(
                        0);
                Diagram ud2 =
                    (Diagram) ((CompoundDiagram) parentAfter)
                        .getChildren()
                        .get(
                        1);
                RuleApplicationSpec rddd =
                    new RuleAppliesToDandDandD(parentAfter, ud1, ud2);
                Rule rjs = RuleJoinSpiders.getRule();
                if (rjs.applyRuleToPart(after, rddd).equals(before)) {
                    result.addStepAtEnd(rjs, rddd, before);
                } else {
                    throw new IllegalArgumentException();
                }
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            ////////////////////////////////////////////////////////////////
            ////////////////////////////////INVERT "SHATTER SPIDER"
            try {
                ShatterSpidersRule ssr = (ShatterSpidersRule) r;
                RuleAppliesToJustADiagram rajd =
                    (RuleAppliesToJustADiagram) ras;
                //
                RuleAppliesToDiagramAndDiagram radd =
                    new RuleAppliesToDiagramAndDiagram(after, before);
                Rule issr = InvertShatterSpidersRule.getRule();

                Diagram parent = before.getParentOf(partBefore);
                if (issr.applyRuleToPart(after, radd).equals(before)) {
                    result.addStepAtEnd(issr, radd, before);
                } else {
                    //System.out.println("can't invert DNF rwd.rules");
                    throw new IllegalArgumentException();
                }
                //
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            ////////////////////////////////////////////////////////////////
            ////////////////////////////////INVERT "ToDNF"
            try {
                ToDNFRule ssr = (ToDNFRule) r;
                RuleAppliesToJustADiagram rajd =
                    (RuleAppliesToJustADiagram) ras;
                //
                RuleAppliesToDiagramAndDiagram radd =
                    new RuleAppliesToDiagramAndDiagram(after, before);
                Rule issr = InvertToDNFRule.getRule();

                Diagram parent = before.getParentOf(partBefore);
                if (issr.applyRuleToPart(after, radd).equals(before)) {
                    result.addStepAtEnd(issr, radd, before);
                } else {
                    throw new IllegalArgumentException();
                }
                //
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            ////////////////////////////////////////////////////////////////
            ////////////////////////////////INVERT "DISTRIBUTE AND OVER OR"
            try {
                RuleDistributeAndOverOr rdaoo = (RuleDistributeAndOverOr) r;
                try {
                    RuleAppliesToDiagramAndDiagrams radd =
                        (RuleAppliesToDiagramAndDiagrams) ras;
                    //System.out.println("in rdaoo section");
                    //System.out.println(""+radd);
                    //"Pand(QorR)and... -> ((PandQ)or(PandR))and..."

                    Vector spec = (Vector) radd.others.clone();
                    Diagram P = (Diagram) spec.get(0);
                    //P is one of the toplevel And-Children
                    CompoundDiagram orChild = (CompoundDiagram) spec.get(1);
                    // orChild is (QorR)
                    spec.remove(P);
                    spec.remove(orChild);
                    // now spec is just Q-children.
                    Vector rchildren = (Vector) orChild.getChildren().clone();
                    rchildren.removeAll(spec);
                    //now rchildren is just R-children.

                    Diagram Q = null;
                    if(spec.size()>1){
                        Q = new OrCompoundDiagram(spec,"Q");
                    } else {
                        Q = (Diagram)spec.get(0);
                    }
                    Diagram R = null;
                    if(rchildren.size()>1){
                        R = new OrCompoundDiagram(rchildren, "R");
                    } else {
                        R = (Diagram)rchildren.get(0);
                    }

                    // either Unitary or Or-compound
                    // build PandQ, PandR and (PandQ)or(PandR)
                    /*System.out.println("inverting rwd.rules with");
                    System.out.println(
                    	"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
                    System.out.println(
                    	"P is " + DiagramFileUser.toSaveString(P));
                    System.out.println(
                    	"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
                    System.out.println(
                    	"orChild is " + DiagramFileUser.toSaveString(orChild));
                    System.out.println(
                    	"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
                    System.out.println(
                    	"Q is " + DiagramFileUser.toSaveString(Q));
                    System.out.println(
                    	"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
                    System.out.println(
                    	"R is " + DiagramFileUser.toSaveString(R));
                    System.out.println(
                    	"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
                    System.out.println(
                    	"partBefore is "
                    		+ DiagramFileUser.toSaveString(partBefore));
                    		*/

                    Vector a = new Vector();
                    a.add(P);
                    a.add(Q);
                    Diagram PandQ = new AndCompoundDiagram(a, "PandQ");
                    a.clear();
                    a.add(P);
                    a.add(R);
                    Diagram PandR = new AndCompoundDiagram(a, "PandR");
                    a.clear();
                    a.add(PandQ);
                    a.add(PandR);
                    Diagram PandQorPandR =
                        new OrCompoundDiagram(a, "(PandQ)or(PandR)");

                    OrCompoundDiagram partAfter = null;
                    // if P and or-child consititutes all children of beforePart
                    // and beforePart has an or-parent
                    // then flattening leaves the partAfter one level up
                    int numChildren = 0;
                    if (P instanceof UnitaryDiagram
                        || P instanceof FalseDiagram
                        || P instanceof OrCompoundDiagram) {
                        numChildren = 1;
                    } else {
                        numChildren =
                            ((CompoundDiagram) P).getChildren().size();
                    }
                    numChildren++;
                    if (numChildren
                        == ((CompoundDiagram) partBefore).getChildren().size()) {
                        // there were no "others" in the and-diagram before the distribution
                        Diagram beforeParent = before.getParentOf(partBefore);
                        if (beforeParent != null) {
                            if (beforeParent instanceof OrCompoundDiagram) {
                                OrCompoundDiagram ocd =
                                    (OrCompoundDiagram) beforeParent;
                                // will find parentAfter at one level up
                                int[] partAfterCoords =
                                    new int[coords.length - 1];
                                for (int i = 0;
                                    i < partAfterCoords.length;
                                    i++) {
                                    partAfterCoords[i] = coords[i];
                                }
                                partAfter =
                                    (OrCompoundDiagram) after.getPartAt(
                                        partAfterCoords);
                            }
                        }
                        // there was no parent before...
                        partAfter = (OrCompoundDiagram) after;
                    } else { // there were "others" in the and-compoundDiagram
                        // partAfter is an Or-diagram child of the corresponding and-parent
                        CompoundDiagram parentAfter =
                            (CompoundDiagram) after.getPartAt(coords);
                        for (int i = 0;
                            i < parentAfter.getChildren().size();
                            i++) {
                            Diagram child =
                                (Diagram) parentAfter.getChildren().get(i);
                            if (child.equals(PandQorPandR)) {
                                partAfter = (OrCompoundDiagram) child;
                                break;
                            }
                        }
                    }
                    // now partAfter is known - seek children like PandQ, PandR
                    Diagram PandQChild = null;
                    boolean hasMatchedPandQ = false;
                    Diagram PandRChild = null;
                    boolean hasMatchedPandR = false;
                    childSearch : for (
                        int i = 0; i < partAfter.getChildren().size(); i++) {
                        Diagram child =
                            (Diagram) partAfter.getChildren().get(i);
                        if (!hasMatchedPandQ && child.equals(PandQ)) {
                            PandQChild = child;
                            hasMatchedPandQ = true;
                            continue childSearch;
                        }
                        if (!hasMatchedPandR && child.equals(PandR)) {
                            PandRChild = child;
                            hasMatchedPandR = true;
                        }
                    }
                    Vector commonality = new Vector();
                    commonality.add(P);
                    //Vector specParts = new Vector();
                    //specParts.add(PandQChild);
                    //specParts.add(PandRChild);
                    //specParts.add(commonality);
                    //System.out.println("provides d,[d2,d3,[d4,d5,...]]");
                    RuleAppliesToDiDiAL radda =
                        new RuleAppliesToDiDiAL(
                            partAfter,
                            PandQChild,
                            PandRChild,
                            commonality);
                    //RuleAppliesToDiagramAndDiagrams rdd =
                    //	new RuleAppliesToDiagramAndDiagrams(partAfter, specParts);
                    Rule rdma = RuleDistributeMergeAnds.getRule();
                    //System.out.println("part is "+partAfter);
                    //System.out.println("PandQChild is "+PandQChild);
                    //System.out.println("PandRChild is "+PandRChild);
                    //System.out.println("commonality is "+commonality);
                    if (rdma.applyRuleToPart(after, radda).equals(before)) {
                        result.addStepAtEnd(rdma, radda, before);
                    } else {
                        throw new IllegalArgumentException();
                    }
                }
                //
                catch (ClassCastException e) {
                    System.out.println("class cast problem in rule inversion");
                    e.printStackTrace();
                }
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            try
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "SIMPLE COMBINING RULE"
                {
                SimpleCombiningRule scr = (SimpleCombiningRule) r;
                // part is an And-Compound diagram
                // after combining, it's replaced with a unitary diagram (eg False)
                Diagram partAfter = after.getPartAt(coords);
                if (partAfter instanceof FalseDiagram) {
                    //System.out.println("inverting from false");
                    RuleAppliesToDiagramAndDiagram radd =
                        new RuleAppliesToDiagramAndDiagram(
                            partAfter,
                            partBefore);
                    Rule rule = RuleFalseImpliesAContradiction.getRule();
                    if (rule.applyRuleToPart(after, radd).equals(before)) {
                        result.addStepAtEnd(rule, radd, before);
                    } else {
                        throw new IllegalArgumentException();
                    }
                    //System.out.println("finished inverting from false");
                    continue stepLoop;
                }
                // apply rwd.rules to duplicate  n times where
                int n = ((CompoundDiagram) partBefore).getChildren().size();
                //System.out.println("duplicate part "+(n-1)+" times");
                RuleAppliesToJustADiagram rajd =
                    new RuleAppliesToJustADiagram(partAfter);
                Rule air = AndIdempotentRule.getRule();
                Diagram nextStep = air.applyRuleToPart(after, rajd);
                result.addStepAtEnd(air, rajd, nextStep);
                int[] newCoords = new int[coords.length + 1];
                for (int i = 0; i < newCoords.length - 1; i++) {
                    newCoords[i] = coords[i];
                }
                newCoords[newCoords.length - 1] = 0;
                for (int i = 1;
                    i < n - 1;
                    i++) { // apply "air" to diagram nextStep at part located at newCoords
                    //System.out.println("after duplication, nextStep is "+nextStep.toSaveString());
                    //System.out.print("coords of newPart are ");
                    //for(int j=0; j<newCoords.length; j++)
                    //{ /**/System.out.print(""+newCoords[j]); }
                    //System.out.println("");
                    Diagram newPart = nextStep.getPartAt(newCoords);
                    //
                    // if newpart == null that's because there were equal children
                    // and the idempotent rwd.rules just split the first it got to
                    //
                    //System.out.println("newPart (for duplication) is "+newPart.toSaveString());
                    rajd = new RuleAppliesToJustADiagram(newPart);
                    nextStep = air.applyRuleToPart(nextStep, rajd);
                    result.addStepAtEnd(air, rajd, nextStep);
                }
                //System.out.println("~~~~~~~~~~~~~~~~~~~~"+result.getLastDiagram());
                // now we have duplicate diags at newCoords which
                // should map to unitary diagrams at newCoords in before
                // after some removal of shading / spiders
                for (int i = 0; i < n; i++) {
                    newCoords[newCoords.length - 1] = i;
                    UnitaryDiagram duplicate =
                        (UnitaryDiagram) nextStep.getPartAt(newCoords);
                    UnitaryDiagram target =
                        (UnitaryDiagram) before.getPartAt(newCoords);
                    //System.out.println("in removal loop~~~~~~~~~~~~~~~~~~~~~~~~~~~~");
                    //System.out.println("duplicate is "+duplicate.toSaveString());
                    //System.out.println("target is "+target.toSaveString());
                    if (duplicate.equals(target)) {
                        break;
                    } else { // need to remove some shading or spiders
                        Vector shadedZonesInDuplicate =
                            duplicate.getCloneOfShadedZones();
                        Vector shadedZonesInTarget =
                            target.getCloneOfShadedZones();
                        while (shadedZonesInDuplicate.size()
                            > shadedZonesInTarget.size()) {
                            //find a zone in duplicate which is not shaded in target
                            //System.out.println(
                            //    "looking for a duplicate which is not shaded in taget");
                            //System.out.println(
                            //    "shaded zones in duplicate:"
                            //        + shadedZonesInDuplicate);
                            //System.out.println(
                            //    "shaded zones in target:"
                            //        + shadedZonesInTarget);
                            Vector szidCopy =
                                (Vector) shadedZonesInDuplicate.clone();
                            //System.out.println(
                            //    "szidcopy before removal:" + szidCopy);
                            szidCopy.removeAll(shadedZonesInTarget);
                            //System.out.println(
                            //    "szidcopy after removal:" + szidCopy);
                            try {
                                Zone z = (Zone) szidCopy.get(0);
                                RuleAppliesToZone raz =
                                    new RuleAppliesToZone(duplicate, z);
                                Rule rule;
                                if (target.getCloneOfZoneSet().contains(z)) {
                                    rule = RuleUnshadeZone.getRule();
                                } else {
                                    rule = RuleDeleteShadedZone.getRule();
                                }
                                nextStep = rule.applyRuleToPart(nextStep, raz);
                                result.addStepAtEnd(rule, raz, nextStep);
                                duplicate =
                                    (UnitaryDiagram) nextStep.getPartAt(
                                        newCoords);
                                shadedZonesInDuplicate =
                                    duplicate.getCloneOfShadedZones();
                            } catch (IndexOutOfBoundsException x) {
                                //x.printStackTrace();
                                System.out.println("problem with szid");
                                System.exit(0);
                            }
                        }
                        Vector spidersInDuplicate = duplicate.getSpiders();
                        Vector spidersInTarget = target.getSpiders();
                        while (spidersInDuplicate.size()
                            > spidersInTarget.size()) {
                            //System.out.println("I need to remove some spiders from");
                            //System.out.println("duplicate is "+duplicate.toSaveString());
                            //System.out.println("in order to get to");
                            //System.out.println("target is "+target.toSaveString());

                            Vector rhsCopy =
                                (Vector) spidersInDuplicate.clone();
                            Vector lhsCopy =
                                (Vector) spidersInTarget.clone();
                            rhsSearch : for (
                                int ii = 0; ii < rhsCopy.size(); ii++) {
                                Spider rhsSpider = (Spider) rhsCopy.get(ii);
                                //System.out.println("considering duplicate spider "+rhsSpider);
                                Vector rhsH = rhsSpider.getHabitat();
                                lhsSearch : for (
                                    int j = 0; j < lhsCopy.size(); j++) {
                                    Spider lhsSpider = (Spider) lhsCopy.get(j);
                                    Vector lhsH = lhsSpider.getHabitat();
                                    //System.out.println("lhsH is "+lhsH);
                                    //System.out.println("rhsH is "+rhsH);
                                    if (rhsH.containsAll(lhsH)
                                        && lhsH.containsAll(
                                            rhsH)) { //System.out.println("found partner in target");
                                        lhsCopy.remove(lhsSpider);
                                        rhsCopy.remove(rhsSpider);
                                        continue rhsSearch;
                                    }
                                }
                            }
                            //System.out.println("spiders which didn't find a partner are "+rhsCopy);
                            Spider s = (Spider) rhsCopy.get(0);
                            //System.out.println("removing spider "+s);
                            RuleAppliesToSpider rasp =
                                new RuleAppliesToSpider(duplicate, s);
                            Rule rds = RuleDeleteSpider.getRule();
                            nextStep = rds.applyRuleToPart(nextStep, rasp);
                            //if(nextStep.isEqualToo(before))
                            //{ result.addStepAtEnd(rds,rasp,before); }
                            //else
                            {
                                result.addStepAtEnd(rds, rasp, nextStep);
                            }
                            duplicate =
                                (UnitaryDiagram) nextStep.getPartAt(newCoords);
                            spidersInDuplicate = duplicate.getSpiders();
                        }
                    }
                }
                continue stepLoop;
                //ProofManager.showNewProof(result, false);
            } catch (ClassCastException e) {
            }
            try
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "P or F -> P"
                {
                FalseWithOrRule fwor = (FalseWithOrRule) r;
                RuleAppliesToDiagramAndDiagrams radd =
                    (RuleAppliesToDiagramAndDiagrams) ras;
                //System.out.println("inverting PorF->P");
                // throwing false away may have resulted in a flattening
                // if partBefore had only falses + one more
                OrCompoundDiagram ocd = (OrCompoundDiagram) partBefore;
                if (ocd.getChildren().size() == (1 + radd.others.size())
                    && coords.length > 0) {
                    // this assumes that coords.length is at least 1 - so
                    // coords = before.getCoords(partBefore);
                    // means that partBefore isn't equal to before
                    int[] reducedCoords = new int[coords.length - 1];
                    for (int i = 0; i < reducedCoords.length; i++) {
                        reducedCoords[i] = coords[i];
                    }
                    CompoundDiagram parentOfRisenOne =
                        (CompoundDiagram) after.getPartAt(reducedCoords);
                    // locate that "risen one" in after
                    Diagram cloneOfRisenOne = fwor.applyRule(radd);
                    // search for risenOne
                    for (int i = 0;
                        i < parentOfRisenOne.getChildren().size();
                        i++) {
                        Diagram child =
                            (Diagram) parentOfRisenOne.getChildren().get(i);
                        if (child.equals(cloneOfRisenOne)) {
                            coords = after.getCoords(child);
                        }
                    }
                }
                Diagram goFrom = after;
                Rule r2 = new RulePToPorF();
                for (int i = 0; i < radd.others.size(); i++) {
                    Diagram part = goFrom.getPartAt(coords);
                    //System.out.println("adding a False diagram back to "+part.toSaveString());
                    RuleAppliesToJustADiagram rajd =
                        new RuleAppliesToJustADiagram(part);
                    goFrom = r2.applyRuleToPart(goFrom, rajd);
                    //if(goFrom.isEqualToo(before))
                    //{ result.addStepAtEnd(r2,rajd,before); }
                    //else
                    {
                        result.addStepAtEnd(r2, rajd, goFrom);
                    }
                }
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            try
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "P and F -> F"
                {
                FalseWithAndRule fwor = (FalseWithAndRule) r;
                RuleAppliesToDiagramAndDiagrams radds =
                    (RuleAppliesToDiagramAndDiagrams) ras;
                //System.out.println("inverting PandF->P");
                // throwing P away may have resulted in a flattening
                // if partBefore had only falses + one more
                AndCompoundDiagram acd = (AndCompoundDiagram) partBefore;

                //System.out.println(
                //	"before is " + DiagramFileUser.toSaveString(before));
                //System.out.println(
                //	"partBefore is " + DiagramFileUser.toSaveString(partBefore));
                //System.out.println(
                //	"acd is " + DiagramFileUser.toSaveString(acd));
                //System.out.println("radds.others is " + radds.others);
                //System.out.println(
                //	"after is " + DiagramFileUser.toSaveString(after));

                for (int i = 0; i < radds.others.size(); i++) {
                    //System.out.println(
                    //	"others("
                    //		+ i
                    //		+ ") is "
                    //		+ DiagramFileUser.toSaveString(
                    //			(Diagram) radds.others.get(i)));
                }

                if (acd.getChildren().size() == (1 + radds.others.size())
                    && coords.length > 0) {
                    // this assumes that coords.length is at least 1 - so
                    // coords = before.getCoords(partBefore);
                    // means that partBefore isn't equal to before
                    //System.out.println("flattening occured");
                    int[] reducedCoords = new int[coords.length - 1];
                    for (int i = 0; i < reducedCoords.length; i++) {
                        reducedCoords[i] = coords[i];
                    }
                    CompoundDiagram parentOfRisenOne =
                        (CompoundDiagram) after.getPartAt(reducedCoords);
                    // locate that "risen one" in after
                    Diagram cloneOfRisenOne = fwor.applyRule(radds);
                    // search for risenOne
                    for (int i = 0;
                        i < parentOfRisenOne.getChildren().size();
                        i++) {
                        Diagram child =
                            (Diagram) parentOfRisenOne.getChildren().get(i);
                        if (child.equals(cloneOfRisenOne)) {
                            coords = after.getCoords(child);
                        }
                    }
                }
                Diagram goFrom = after;
                //System.out.println(
                //	"goFrom = after is " + DiagramFileUser.toSaveString(after));
                Rule r2 = RuleFalseImpliesAnything.getRule();
                for (int i = 0; i < radds.others.size(); i++) {
                    Diagram part = goFrom.getPartAt(coords);
                    //System.out.println("adding a diagram back to "+part.toSaveString());
                    // pick out F from radds.others = part's children
                    // and apply 
                    //System.out.println("want to apply F->Anything");
                    //System.out.println(
                    //	"part is " + DiagramFileUser.toSaveString(part));
                    // pick a F out of radd.others
                    FalseDiagram f = null;
                    if (part instanceof FalseDiagram) {
                        f = (FalseDiagram) part;
                    } else {
                        Vector parts =
                            ((CompoundDiagram) part).getChildren();
                        falseLoop : for (int ti = 0; ti < parts.size(); ti++) {
                            Diagram other = (Diagram) parts.get(ti);
                            if (other instanceof FalseDiagram) {
                                f = (FalseDiagram) other;
                                break falseLoop;
                            }
                        }
                        if (f == null) {
                            System.out.println(
                                "radds.others had no falses - error!!");
                        }
                    }
                    // build the "Anything" which F maps to
                    // it's really F and P and Q and...
                    // where P and Q and .. are "others"
                    Vector anythingComponents = new Vector();
                    anythingComponents.add(f.getClone());
                    for (int it = 0; it < acd.getChildren().size(); it++) {
                        Diagram anythingCandidate =
                            (Diagram) acd.getChildren().get(it);
                        if (!radds.others.contains(anythingCandidate)) {
                            anythingComponents.add(anythingCandidate);
                        }
                    }
                    Diagram anything =
                        new AndCompoundDiagram(anythingComponents, "a");
                    RuleAppliesToDiagramAndDiagram radd =
                        new RuleAppliesToDiagramAndDiagram(f, anything);

                    goFrom = r2.applyRuleToPart(goFrom, radd);
                    //System.out.println(
                    //	"after applying rule, goFrom is "
                    //		+ DiagramFileUser.toSaveString(after));

                    if (goFrom.equals(before)) {
                        result.addStepAtEnd(r2, radd, before);
                    } else {
                        result.addStepAtEnd(r2, radd, goFrom);
                    }
                    //System.out.println("result built");
                }
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            try
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "P or P -> P"
                {
                RuleReverseOrIdempotent rroi = (RuleReverseOrIdempotent) r;
                RuleAppliesToDiagramAndDiagrams radd =
                    (RuleAppliesToDiagramAndDiagrams) ras;
                // removing duplicates may have resulted in a flattening
                // if partBefore had only falses + one more
                OrCompoundDiagram ocd = (OrCompoundDiagram) partBefore;
                //System.out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
                //System.out.println("num children before is "+ocd.getChildren().size());
                //System.out.println("num identified is "+radd.others.size());
                Diagram partAfter = null;
                //System.out.println("partBefore is "+partBefore.toDebugString());
                //System.out.println("after is "+after.toDebugString());
                Diagram p = (Diagram) radd.others.get(0);
                if (ocd.getChildren().size() == radd.others.size()) {
                    partAfter = after.getPartAt(coords);
                } else {
                    CompoundDiagram parent =
                        (CompoundDiagram) after.getPartAt(coords);
                    Vector children = parent.getChildren();
                    for (int i = 0; i < children.size(); i++) {
                        Diagram child = (Diagram) children.get(i);
                        if (child.equals(p)) {
                            partAfter = child;
                            break;
                        }
                    }
                }
                //System.out.println("partAfter is "+partAfter.toDebugString());
                Diagram goFrom = after;
                Rule r2 = RulePToPOrRubbish.getRule();
                for (int i = 0; i < radd.others.size() - 1; i++) {
                    Diagram part = null;
                    if (i == 0) {
                        part = partAfter;
                    } else {
                        CompoundDiagram parent =
                            (CompoundDiagram) goFrom.getPartAt(coords);
                        Vector children = parent.getChildren();
                        for (int ii = 0; ii < children.size(); ii++) {
                            Diagram child = (Diagram) children.get(ii);
                            if (child.equals(p)) {
                                part = child;
                                break;
                            }
                        }
                    }
                    //System.out.println("adding a False diagram back to "+part.toDebugString());
                    RuleAppliesToDiagramAndDiagram radd2 =
                        new RuleAppliesToDiagramAndDiagram(part, part);
                    goFrom = r2.applyRuleToPart(goFrom, radd2);
                    //if(goFrom.isEqualToo(before))
                    //{ result.addStepAtEnd(r2,rajd,before); }
                    //else
                    {
                        result.addStepAtEnd(r2, radd2, goFrom);
                    }
                }
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            try
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "Excluded middle"
                {
                RuleExcludedMiddle rem = (RuleExcludedMiddle) r;
                RuleAppliesToZone raz = (RuleAppliesToZone) ras;
                // need to build a RuleAppliesToDandDandD
                // where 1st D is an or-compoundDiagram
                // and next two differ by shading+spiderFoot
                //
                // find out whether partBefore had an or-parent
                // if it did, then 1stD is at layer above
                // otherwise 1stD is at same coords as partBefore
                //System.out.println("before is "+before.toSaveString());
                //try
                //{ CompoundDiagram cd = (CompoundDiagram)before;
                //  /**/System.out.println("before.child1 is "+cd.getChildren().get(0).hashCode());
                //  /**/System.out.println("before.child2 is "+cd.getChildren().get(1).hashCode());
                //}
                //catch(Exception e) // crash is appearing here  ONTRAIN
                //{}
                //System.out.println("partBefore is "+partBefore.toSaveString());
                //System.out.println("partBefore is "+partBefore.hashCode());
                Diagram beforeParent = before.getParentOf(partBefore);
                Diagram firstD = null;
                try {
                    OrCompoundDiagram ocd = (OrCompoundDiagram) beforeParent;
                    int[] reducedCoords = new int[coords.length - 1]; // CRASH
                    for (int i = 0; i < reducedCoords.length; i++) {
                        reducedCoords[i] = coords[i];
                    }
                    firstD = after.getPartAt(reducedCoords);
                } catch (ClassCastException x) {
                    firstD = after.getPartAt(coords);
                } catch (NegativeArraySizeException x) {
                    firstD = after.getPartAt(coords);
                }
                Diagram outcome = rem.applyRule(raz);
                Vector children =
                    ((OrCompoundDiagram) outcome).getChildren();
                Diagram child1 = (Diagram) children.get(0);
                Diagram child2 = (Diagram) children.get(1);
                children = ((OrCompoundDiagram) firstD).getChildren();
                boolean matched1st = false;
                boolean matched2nd = false;
                childSearch : for (int i = 0; i < children.size(); i++) {
                    Diagram child = (Diagram) children.get(i);
                    if (!matched1st && child.equals(child1)) {
                        child1 = child;
                        matched1st = true;
                        continue childSearch;
                    }
                    if (!matched2nd && child.equals(child2)) {
                        child2 = child;
                        matched2nd = true;
                    }
                }
                RuleAppliesToDandDandD raddd =
                    new RuleAppliesToDandDandD(firstD, child2, child1);
                Rule rule = RuleReverseExcludedMiddle.getRule();
                if (rule.applyRuleToPart(after, raddd).equals(before)) {
                    result.addStepAtEnd(rule, raddd, before);
                } else {
                    throw new IllegalArgumentException();
                }
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            try
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "Reverse Excluded middle"
                {
                RuleReverseExcludedMiddle rrem = (RuleReverseExcludedMiddle) r;
                RuleAppliesToDandDandD raddd = (RuleAppliesToDandDandD) ras;
                // raddd has other1 and other2 which are unitary diagrams
                // whose parent is an or-compound diagram
                Diagram partToApplyInverseTo = null;

                UnitaryDiagram d1 = (UnitaryDiagram) raddd.other1;
                UnitaryDiagram d2 = (UnitaryDiagram) raddd.other2;
                //System.out.println("d1 is "+d1.toDebugString());
                //System.out.println("d2 is "+d2.toDebugString());
                if (((OrCompoundDiagram) partBefore).getChildren().size()
                    > 2) {
                    // we either have
                    // or(p,q,r,...) -> or(pqMerged, r,...)
                    // ie. coords of inversion are like p,q maybe last index=1?
                    // could seach under part = parent for a pqMerged diagram
                    //System.out.println("Reverse excluded middle merged into or");
                    Diagram parentRhs = after.getPartAt(coords);
                    Vector pAndQ = new Vector();
                    pAndQ.add(d1);
                    pAndQ.add(d2);
                    OrCompoundDiagram ocd =
                        new OrCompoundDiagram(pAndQ, "whatever");
                    RuleAppliesToDandDandD raddd2 =
                        new RuleAppliesToDandDandD(ocd, d1, d2);
                    Diagram PQMerged =
                        RuleReverseExcludedMiddle.getRule().applyRule(raddd2);
                    //System.out.println("without merging outcome would've been");
                    //System.out.println("PQMerged:"+PQMerged.toDebugString());

                    for (int i = 0;
                        i < ((CompoundDiagram) parentRhs).getChildren().size();
                        i++) {
                        Diagram rhsChild =
                            (Diagram) ((CompoundDiagram) parentRhs)
                                .getChildren()
                                .get(
                                i);
                        //System.out.println("compare merged one with rhsChild:"+rhsChild.toDebugString());
                        if (rhsChild.equals(PQMerged)) {
                            partToApplyInverseTo = rhsChild;
                            break;
                        }
                    }
                } else {
                    // or
                    // and(or(p,q),r,...) -> and(pqMerged, r,...)
                    // ie. coords of inversion are those of part = parent of p,q
                    // or
                    // or(p,q) -> pqMerged
                    // ie. coords of inversion are those of part = parent of p,q
                    partToApplyInverseTo = after.getPartAt(coords);
                }
                //System.out.println("located part to apply inverse to "+
                //    partToApplyInverseTo);
                Zone zoneToApplyInverseTo = null;
                Iterator zi = d1.getZoneIterator();
                while(zi.hasNext()){
                    Zone z = (Zone)zi.next();
                    // see whether z is same in d1 and d2
                    // must be present in both
                    if ((d1.containsShaded(z) && !d2.containsShaded(z))
                        || (!d1.containsShaded(z) && d2.containsShaded(z))) {
                        zoneToApplyInverseTo = z;
                        break;
                    }
                }
                // need to build a RuleAppliesToZone
                // where z is the zone which is different in other1 and other2
                //System.out.println("apply to zone "+zoneToApplyInverseTo);
                //System.out.println("apply to part "+partToApplyInverseTo);
                RuleAppliesToZone raz =
                    new RuleAppliesToZone(
                        partToApplyInverseTo,
                        zoneToApplyInverseTo);
                Rule rule = RuleExcludedMiddle.getRule();
                if (rule.applyRuleToPart(after, raz).equals(before)) {
                    result.addStepAtEnd(rule, raz, before);
                } else {
                    throw new IllegalArgumentException();
                }
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            try
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "P->P or Rubbish"
                ////////////////////////////////WHEN P equals Rubbish!
                {
                RulePToPOrRubbish rpToPOrPubbish = (RulePToPOrRubbish) r;
                //System.out.println("inverting P->P or R");
                RuleAppliesToDiagramAndDiagram radd =
                    (RuleAppliesToDiagramAndDiagram) ras;
                // raddd has other1 and other2 which are unitary diagrams
                // whose parent is an or-compound diagram
                Diagram partToApplyInverseTo = null;

                Diagram p = radd.d;
                Diagram rubbish = radd.other;
                if (!p.equals(rubbish)) {
                    throw new ClassCastException();
                }
                Vector children = new Vector();
                //System.out.println("partBefore is "+partBefore);
                // find out whether partBefore has a parent which is an or-diagram
                if (coords.length > 0
                    && before.getParentOf(partBefore)
                        instanceof OrCompoundDiagram) {
                    // we either have
                    // or(p,q,...) -> or(p,p, q,...)
                    // ie. coords of inversion are one layer above p
                    int[] reducedCoords = new int[coords.length - 1];
                    for (int i = 0; i < reducedCoords.length; i++) {
                        reducedCoords[i] = coords[i];
                    }
                    partToApplyInverseTo = after.getPartAt(reducedCoords);
                    // populate children by searching for two things like p
                    Vector childrenMaybe =
                        ((OrCompoundDiagram) partToApplyInverseTo)
                            .getChildren();
                    for (int i = 0; i < childrenMaybe.size(); i++) {
                        Diagram childMaybe = (Diagram) childrenMaybe.get(i);
                        if (childMaybe.equals(p)) {
                            children.add(childMaybe);
                            if (children.size() == 2) {
                                break;
                            }
                        }
                    }
                } else {
                    // or
                    // and(p,r,...) -> and(or(p,p), r,...)
                    // ie. coords of inversion are those of p
                    partToApplyInverseTo = after.getPartAt(coords);
                    children =
                        ((CompoundDiagram) partToApplyInverseTo).getChildren();
                }
                //System.out.println("located part to apply inverse to "+
                //    partToApplyInverseTo);
                // need to build a RuleAppliesToDiagramAndDiagrams
                //System.out.println("1.provides d,[d1,d2,..]");
                RuleAppliesToDiagramAndDiagrams radds =
                    new RuleAppliesToDiagramAndDiagrams(
                        partToApplyInverseTo,
                        children);
                Rule rule = RuleReverseOrIdempotent.getRule();
                if (rule.applyRuleToPart(after, radds).equals(before)) {
                    result.addStepAtEnd(rule, radds, before);
                } else {
                    throw new IllegalArgumentException();
                }
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            try {
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "RemoveNotRuleComplex"
                ////////////////////////////////
                RemoveNotRuleComplex rnr = (RemoveNotRuleComplex) r;
                //System.out.println("inverting RemoveNotRule");
                // the rule turned not(d) into a disjunction of d1...dn
                // could have been lifted into next disjunction up.
                //
                // find out whether the parent of partBefore in before
                // was an or-diagram
                Diagram parent = before.getParentOf(partBefore);
                // if it was, then part for reverse must be that with partAfter
                // substituted
                if (parent == null || !(parent instanceof OrCompoundDiagram)) {
                    // the orcompound result of "remove not" has not been lifted
                    //
                    //put junk into proof!!
                    // why did I make more effort than this with other inversions?
                    //
                    result.addStepAtEnd(
                        InvertRemoveNotRule.getRule(),
                        new RuleAppliesToJustADiagram(parent),
                        before);
                    //
                    continue stepLoop;
                } else {
                    OrCompoundDiagram ocd = (OrCompoundDiagram) parent;
                    // if it was, then part for reverse must be that with partAfter
                    // substituted
                    int[] preParentCoords = before.getCoords(ocd);
                    CompoundDiagram parentAfter =
                        (CompoundDiagram) after.getPartAt(preParentCoords);

                    //
                    //put junk into proof!!
                    // why did I make more effort than this with other inversions?
                    //
                    result.addStepAtEnd(
                        InvertRemoveNotRule.getRule(),
                        new RuleAppliesToJustADiagram(parent),
                        before);
                    continue stepLoop;
                }
            } catch (ClassCastException e) {
            }
            try {
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "RemoveNotNotRule"
                ////////////////////////////////
                RemoveNotNotRule rnnr = (RemoveNotNotRule) r;
                //System.out.println("inverting RemoveNotNotRule");
                // the rule turned not(not(d)) into d
                int[] coordsBefore = before.getCoords(partBefore);
                Diagram partAfter = after.getPartAt(coordsBefore);
                result.addStepAtEnd(
                    InsertNotNotRule.getRule(),
                    new RuleAppliesToJustADiagram(partAfter),
                    before);
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            try {
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "InsertNotNotRule"
                ////////////////////////////////
                InsertNotNotRule innr = (InsertNotNotRule) r;
                //System.out.println("inverting RemoveNotNotRule");
                // the rule turned not(not(d)) into d
                int[] coordsBefore = before.getCoords(partBefore);
                Diagram partAfter = after.getPartAt(coordsBefore);
                result.addStepAtEnd(
                    RemoveNotNotRule.getRule(),
                    new RuleAppliesToJustADiagram(partAfter),
                    before);
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            try {
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "PushNotsToLeaves"
                ////////////////////////////////
                RulePushNotsToLeaves rptl = (RulePushNotsToLeaves) r;
                //System.out.println("inverting RemoveNotNotRule");
                // the rule turned not(not(d)) into d
                int[] coordsBefore = before.getCoords(partBefore);
                Diagram partAfter = after.getPartAt(coordsBefore);
                result.addStepAtEnd(
                    RulePullNotsBackFromLeaves.getRule(),
                    new RuleAppliesToJustADiagram(partAfter),
                    before);
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            try {
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "OrIdempotentRule"
                ////////////////////////////////
                OrIdempotentRule rnnr = (OrIdempotentRule) r;
                //System.out.println("inverting RemoveNotNotRule");
                // the rule turned not(not(d)) into d
                int[] coordsBefore = before.getCoords(partBefore);
                Diagram partAfter = after.getPartAt(coordsBefore);
                result.addStepAtEnd(
                    RuleReverseOrIdempotent.getRule(),
                    new RuleAppliesToJustADiagram(partAfter),
                    before);
                continue stepLoop;
            } catch (ClassCastException e) {
            }

            try {
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "NotTrueIsFalseRule"
                ////////////////////////////////
                NotTrueIsFalseRule ntfr = (NotTrueIsFalseRule) r;
                //System.out.println("inverting NotTrueIsFalseRule");
                // the rule turned not(T) into F
                result.addStepAtEnd(
                    NotFalseIsTrueRule.getRule(),
                    new RuleAppliesToJustADiagram(partBefore),
                    before);
                continue stepLoop;
            } catch (ClassCastException e) {
            }
            try {
                ////////////////////////////////////////////////////////////////
                ////////////////////////////////INVERT "NotFalseIsTrueRule"
                ////////////////////////////////
                NotFalseIsTrueRule nftr = (NotFalseIsTrueRule) r;
                //System.out.println("inverting NotFalseIsTrueRule");
                // the rule turned not(T) into F
                result.addStepAtEnd(
                    NotTrueIsFalseRule.getRule(),
                    new RuleAppliesToJustADiagram(partBefore),
                    before);
                continue stepLoop;
            } catch (ClassCastException e) {
            }

            // all continues happened inside try-blocks
            //System.out.println("can't invert proof step:" + r);
            //ProofFileUser.saveToFile(p1);
            //System.exit(0);
            throw new IllegalArgumentException(); // can't invert step
        }
        return result;
    }

}
