package rwd.rules.autoproof;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import java.util.Vector;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.rules.Proof;
import rwd.rules.Rule;
import rwd.rules.choicespec.RuleSplitSpider;
import rwd.abstractsyntax.spiderdiagram.Spider;
import rwd.rules.application.RuleAppliesToSpiderAndRegion;

public class SlowSpiderSplitter {
	public static Proof splitAllSpiders(Diagram d) {
		//Diagram diag = d.getClone();
		Proof p = new Proof(d);
		Rule rss = RuleSplitSpider.getRule();
		partLoop : while (true) {
			Vector parts = d.getUnitaryParts();
			for (int i = 0; i < parts.size(); i++) {
				UnitaryDiagram ud = (UnitaryDiagram) parts.get(i);
				Vector spiders = ud.getSpiders();
				for (int j = 0; j < spiders.size(); j++) {
					Spider s = (Spider) spiders.get(j);
					if (s.getHabitat().size() > 1) {
						Vector region = new Vector();
						region.add(s.getHabitat().get(0));
						RuleAppliesToSpiderAndRegion rasr =
							new RuleAppliesToSpiderAndRegion(ud, s, region);
						d = rss.applyRuleToPart(d, rasr);
						p.addStepAtEnd(rss, rasr, d);
						continue partLoop;
					}
				}
			}
			break partLoop;
		}
		return p;
	}
}
