package rwd.rules.choicespec;
import java.util.Vector;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.FalseDiagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleAppliesToDiagramAndDiagrams;
import rwd.rules.application.RuleApplicationSpec;

public class FalseWithAndRule extends RuleWithChoice {
	private FalseWithAndRule() {
		super("sd: PandF->F");
	}
	private static Rule example = null;
	public static Rule getRule() {
		if (example == null) {
			example = new FalseWithAndRule();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;
    }

	public boolean canApplyTo(Diagram d) {
		if (d instanceof AndCompoundDiagram) {
			AndCompoundDiagram acd = (AndCompoundDiagram) d;
			Vector children = (Vector) (acd.getChildren().clone());
			for (int i = 0; i < children.size(); i++) {
				Diagram d2 = (Diagram) (children.get(i));
				if (d2 instanceof FalseDiagram) {
					return true;
				}
			}
		}
		return false;
	}

	public Vector getApplicationPossibilities(Diagram d) { //System.out.println("getting app possiobilities for remove false");
		//System.out.println("from diagram "+d.toSaveString());
		Vector result = new Vector();
		if (d instanceof AndCompoundDiagram) {
			AndCompoundDiagram acd = (AndCompoundDiagram) d;
			Vector children = (Vector) (acd.getChildren().clone());
			int numFalses = 0;
			for (int i = 0; i < children.size(); i++) {
				Diagram d2 = (Diagram) (children.get(i));
				if (d2 instanceof FalseDiagram) {
					numFalses++;
				}
			}
			if (numFalses == 0) {
				return result;
			}
			for (int i = 0; i < children.size(); i++) {
				Diagram d2 = (Diagram) (children.get(i));
				if (!(d2 instanceof FalseDiagram && numFalses == 1)) {
					Vector childrenCopy = (Vector) children.clone();
					childrenCopy.remove(d2);
					//System.out.println("3. providing d,[d2,d3,...]");
					result.add(
						new RuleAppliesToDiagramAndDiagrams(acd, childrenCopy));
				}
			}
		}
		//System.out.println("result is "+result);
		return result;
	}

	public Diagram applyRule(RuleApplicationSpec r) {
        return new FalseDiagram("f");
	}
}
