package rwd.rules.choicespec;

import java.util.Vector;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.application.RuleAppliesToJustADiagram;
import rwd.rules.application.RuleAppliesToDiagramAndDiagram;
import rwd.rules.nospec.RemoveNotRule;

public class InvertRemoveNotRule extends RuleWithChoice {
	private InvertRemoveNotRule() {
		super("sd: invert \"remove not\"");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new InvertRemoveNotRule();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;
    }

	public boolean canApplyTo(Diagram d) {
		throw new IllegalArgumentException();
	}

	public Diagram applyRule(RuleApplicationSpec r) {
		RuleAppliesToDiagramAndDiagram radd =
			(RuleAppliesToDiagramAndDiagram) r;
		Diagram d = radd.d;
		Diagram target = radd.other;
		if (RemoveNotRule.getRule()
			.applyRule(new RuleAppliesToJustADiagram(target))
			.equals(d)) {
			return target;
		} else {
			return null;
		}
	}
    public Vector getApplicationPossibilities(Diagram d) {
        throw new IllegalArgumentException();
    }
}
