package rwd.rules.choicespec;

import java.util.Vector;

import rwd.abstractsyntax.spiderdiagram.CompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.OrCompoundDiagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
import rwd.rules.application.RuleAppliesToDiagramAndDiagram;

public class RuleOrAbsorbtion extends RuleWithChoice {
    private RuleOrAbsorbtion() {
        super("sd: Por(PandQ)->P");
    }
    private static Rule example = null;
    public static Rule getRule() {
        if (example == null) {
            example = new RuleOrAbsorbtion();
        }
        return example;
    }
    public boolean isInvertible() {
        return false;
    }

    public boolean canApplyTo(Diagram d) {
        Vector result = new Vector();
        // d must cast into an and-diagram
        if (d instanceof OrCompoundDiagram) {
            OrCompoundDiagram ocd = (OrCompoundDiagram) d;
            Vector children = ocd.getChildren();            
            Vector andChildren = new Vector();            
            for (int i = 0; i < children.size(); i++) {
                Diagram child = (Diagram) children.get(i);
                if(child instanceof AndCompoundDiagram){
                    andChildren.add(child);
                }
            }
            for (int i = 0; i < children.size(); i++) {
                Diagram child = (Diagram) children.get(i);
                // a candidate for P
                for (int j = 0; j < andChildren.size(); j++) {
                    // a candidate for P and Q
                    AndCompoundDiagram andChild = (AndCompoundDiagram) andChildren.get(j);
                    Vector andCChildren= andChild.getChildren();
                    for (int k = 0; k < andCChildren.size(); k++) {
                        Diagram andCChild = (Diagram) andCChildren.get(k);
                        if(child.equals(andCChild)){
                            return true;
                        }                        
                    }
                }
            }                        
        }
        return false;
    }

    public Vector getApplicationPossibilities(Diagram d) {
        Vector result = new Vector();
        // d must cast into an and-diagram
        if (d instanceof OrCompoundDiagram) {
            OrCompoundDiagram ocd = (OrCompoundDiagram) d;
            Vector children = ocd.getChildren();            
            Vector andChildren = new Vector();            
            for (int i = 0; i < children.size(); i++) {
                Diagram child = (Diagram) children.get(i);
                if(child instanceof AndCompoundDiagram){
                    andChildren.add(child);
                }
            }
            for (int i = 0; i < children.size(); i++) {
                Diagram child = (Diagram) children.get(i);
                // a candidate for P
                for (int j = 0; j < andChildren.size(); j++) {
                    // a candidate for P and Q
                    AndCompoundDiagram andChild = (AndCompoundDiagram) andChildren.get(j);
                    Vector andCChildren= andChild.getChildren();
                    for (int k = 0; k < andCChildren.size(); k++) {
                        Diagram andCChild = (Diagram) andCChildren.get(k);
                        if(child.equals(andCChild)){
                            result.add(new RuleAppliesToDiagramAndDiagram(d,andChild));
                        }                        
                    }
                }
            }                        
        }
        return result;
    }

    public Diagram applyRule(RuleApplicationSpec r) {
        Object d = null;
        RuleAppliesToDiagramAndDiagram radd =
            (RuleAppliesToDiagramAndDiagram) r;
        Diagram toRemove = radd.other;
        int[] coords = radd.d.getCoords(toRemove);
        Diagram outcome = radd.d.getClone();
        Vector children = ((CompoundDiagram)outcome).getChildren();
        Diagram part = outcome.getPartAt(coords);
        children.remove(part);
        if(children.size()==1){
            return (Diagram)children.get(0);
        } else {
            return outcome;
        }
    }
}
