/*
 * Created on 22-Nov-2003
 */
package rwd.rules.heuristics;

import java.util.Vector;
import java.util.HashMap;
import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.CompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.DiagramFileUser;
import rwd.abstractsyntax.spiderdiagram.FalseDiagram;
import rwd.abstractsyntax.spiderdiagram.NotCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.OrCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.rules.Proof;
import rwd.rules.ProofGetterRandom;
import rwd.rules.Rule;
import rwd.rules.choicespec.RuleExcludedMiddle;
import rwd.rules.choicespec.RuleSplitSpider;
import rwd.rules.inputspec.RuleAddContour;
import rwd.rules.nospec.AndIdempotentRule;
import rwd.rules.nospec.OrIdempotentRule;

/**
 * @author jaf28
 * One component for a compound diagram heuristic
 */
public class CompoundNotNumMeasure {

    public static int getMeasure(Diagram d,boolean isMeasure1) {
        previousExamples.clear();
        //try{
        return getMeasureAlteringD((Diagram) d.getClone(),isMeasure1);
        //} catch(StackOverflowError x){
        //    System.out.println("stack overflow");
        //    System.exit(0);
        //}
        //return 0;
    }

    private static Vector previousExamples = new Vector();

    private static int getMeasureAlteringD(Diagram d,boolean isMeasure1) {
        Diagram forPrinting = (Diagram) d.getClone();

        for (int i = 0; i < previousExamples.size(); i++) {
            Diagram pe = (Diagram) previousExamples.get(i);
            if (pe.equals(d)) {
                System.out.println("stack overflow ahead");
                System.out.println(
                    "previous examples were " + previousExamples);
                System.out.println("this task is " + d);
                System.exit(0);
            }
        }
        previousExamples.add(d.getClone());

        boolean isDebug = false;

        if (isDebug) {
            System.out.println("diagram is " + DiagramFileUser.toSaveString(d));
        }

        if (d instanceof FalseDiagram) {
            if(isMeasure1){
                return Integer.MAX_VALUE;
            } else{
                return 0;
            }
            
        } else if (d instanceof UnitaryDiagram) {
            if(isMeasure1){
                return 0;
            } else {
                return 1;
            }
        } else if (d instanceof NotCompoundDiagram) {
            Diagram child =(Diagram) (((NotCompoundDiagram) d).getChildren().get(0));
            int result;
            if(child instanceof UnitaryDiagram){
                if(isMeasure1){
                    result = 1; 
                } else {
                    result = 0; 
                }
            } else {
                result = 1+getMeasureAlteringD(child,!isMeasure1);
            }
            if (isDebug) {
                System.out.println("measure for " + d + " is " + result);
            }
            return result;

        } else if (d instanceof CompoundDiagram) {
            CompoundDiagram cd = (CompoundDiagram)d;
            Diagram child1 = (Diagram)cd.getChildren().get(0);
            int result1 = getMeasureAlteringD(child1,isMeasure1);
            int result2;
            if(cd.getChildren().size()==2){
                Diagram child2 = (Diagram)cd.getChildren().get(1);
                result2 = getMeasureAlteringD(child2,isMeasure1);                
            } else {
                cd.getChildren().remove(child1);
                result2 = getMeasureAlteringD(cd,isMeasure1);                
            }
            if(isMeasure1 && cd instanceof AndCompoundDiagram
            ||
              !isMeasure1 && cd instanceof OrCompoundDiagram){
                return Math.max(result1,result2);
            } else {
                return Math.min(result1,result2);
            }
        }
        throw new IllegalArgumentException();
    }

    private static int andNumBefore, andNumAfter, orNumBefore, orNumAfter;
    private static Diagram start, end;
    private static boolean andNumUnchanged() {
        return andNumHasntGrown() && andNumHasntShrunk();
    }
    private static boolean orNumUnchanged() {
        return orNumHasntGrown() && orNumHasntShrunk();
    }
    private static boolean andNumHasntGrown() {
        return andNumBefore >= andNumAfter;
    }
    private static boolean orNumHasntGrown() {
        return orNumBefore >= orNumAfter;
    }
    private static boolean andNumHasntShrunk() {
        return andNumAfter >= andNumBefore;
    }
    private static boolean orNumHasntShrunk() {
        return orNumAfter >= orNumBefore;
    }
    private static boolean andNumHasntChangedByMoreThanOne() {
        return Math.abs(andNumAfter - andNumBefore) <= 1;
    }
    private static boolean orNumHasntChangedByMoreThanOne() {
        return Math.abs(orNumAfter - orNumBefore) <= 1;
    }

    private static void showreport(String message) {
        System.out.println(message);
        //System.out.println(
        //    "start diagram is " + DiagramFileUser.toSaveString(start));
        //System.out.println(
        //    "result diagram is " + DiagramFileUser.toSaveString(end));
        System.out.println("andNumBefore " + andNumBefore);
        System.out.println("andNumAfter " + andNumAfter);
        System.out.println("orNumBefore " + orNumBefore);
        System.out.println("orNumAfter " + orNumAfter);
    }

    public static void main(String args[]) {
        // build suitable rule set
        HashMap resultsHM = new HashMap();
        Vector HRules = HeuristicProofWriter.compoundHRules;
        Rule[] rules = new Rule[HRules.size()];
        for (int i = 0; i < HRules.size(); i++) {
            rules[i] = (Rule) HRules.get(i);
            resultsHM.put(rules[i].name, new Integer(0));
        }

        // build one-step proofs        
        ProofGetterRandom pgr1 = new ProofGetterRandom(2, 3, 2, 1, rules);
        ProofGetterRandom pgr2 = new ProofGetterRandom(1, 1, 2, 6, rules);
        ProofGetterRandom pgr3 = new ProofGetterRandom(0, 3, 2, 2, rules);

        // see how the measures change
        for (int i = 0; i < 500000; i++) {
            if (i % 10000 == 0) {
                System.out.println("" + i);
            }
            Proof p = null;
            if (i % 3 == 0) {
                p = pgr1.getProof(1);
            } else if (i % 3 == 1) {
                p = pgr2.getProof(1);
            } else {
                p = pgr3.getProof(1);
            }
            if (p.numSteps() == 0) {
                i--;
            } else {
                start = p.getFirstDiagram();
                end = p.getLastDiagram();
                andNumBefore = getMeasure(start, true);
                orNumBefore = getMeasure(start, false);
                andNumAfter = getMeasure(end, true);
                orNumAfter = getMeasure(end, false);
                Rule r = p.getImminentRule();
                // log which rules we have experienced
                resultsHM.put(
                    r.name,
                    new Integer(
                        ((Integer) (resultsHM.get(r.name))).intValue() + 1));
                // by default we expect the measure to be left unchanged
                if (andNumUnchanged() && orNumUnchanged()) {
                } else if (r instanceof RuleAddContour) {
                    if (andNumHasntShrunk()
                        && andNumHasntGrown()
                        && andNumHasntChangedByMoreThanOne()
                        && orNumHasntShrunk()
                        && orNumHasntGrown()
                        && orNumHasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof AndIdempotentRule) {
                    if (andNumHasntShrunk()
                        && andNumHasntGrown()
                        && andNumHasntChangedByMoreThanOne()
                        && orNumHasntShrunk()
                        && orNumHasntGrown()
                        && orNumHasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof OrIdempotentRule) {
                    if (andNumHasntShrunk()
                        && andNumHasntGrown()
                        && andNumHasntChangedByMoreThanOne()
                        && orNumHasntShrunk()
                        && orNumHasntGrown()
                        && orNumHasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof RuleSplitSpider) {
                    if (andNumHasntShrunk()
                        && andNumHasntGrown()
                        && andNumHasntChangedByMoreThanOne()
                        && orNumHasntShrunk()
                        && orNumHasntGrown()
                        && orNumHasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof RuleExcludedMiddle) {
                    if (andNumHasntShrunk()
                        && andNumHasntGrown()
                        && andNumHasntChangedByMoreThanOne()
                        && orNumHasntShrunk()
                        && orNumHasntGrown()
                        && orNumHasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else {
                    showreport(" unexpected change : " + r);
                }
            }
        }
        System.out.println("");
        for (int i = 0; i < HRules.size(); i++) {
            Rule r = (Rule) HRules.get(i);
            System.out.println("" + resultsHM.get(r.name) + " " + r.name);
        }
    }
}
