/*
 * Created on 22-Nov-2003
 *
 */
package rwd.rules.heuristics;


/**
 * @author jaf28
 * One component for a compound diagram heuristic
 */
public class CompoundZoneMeasure {
// PLEASE REMOVE ME FROM CVS
/*    public static Vector getMeasure(Diagram d, boolean isMeasure1) {
        return getMeasure(d, isMeasure1, d);
    }
  */  
/*    public static Vector getMeasure(
        Diagram d,
        boolean isMeasure1,
        Diagram context) {
        d = (Diagram) (d.getClone());
        context = (Diagram) (context.getClone());
        // find universal set of contours
        Vector allContours = new Vector();
        /Vector leaves1 = d.getUnitaryParts();
        /for (int i = 0; i < leaves1.size(); i++) {
        /    UnitaryDiagram leaf = (UnitaryDiagram) leaves1.get(i);
        /    if (!(leaf instanceof FalseDiagram)) {
        /        Vector contours = leaf.getContours();
        /        for (int j = 0; j < contours.size(); j++) {
        /            Contour c = (Contour) contours.get(j);
        /            if (!allContours.contains(c)) {
        /                allContours.add(c);
        /            }
        /        }
        /    }
        }
        
        Vector leaves2 = context.getUnitaryParts();
        for (int i = 0; i < leaves2.size(); i++) {
            UnitaryDiagram leaf = (UnitaryDiagram) leaves2.get(i);
            if (!(leaf instanceof FalseDiagram)) {
                Vector contours = leaf.getContours();
                for (int j = 0; j < contours.size(); j++) {
                    Contour c = (Contour) contours.get(j);
                    if (!allContours.contains(c)) {
                        allContours.add(c);
                    }
                }
            }
        }
        // turn to contour form
        contourFormLoop : while (true) {
            Vector leaves3 = d.getUnitaryParts();
            for (int i = 0; i < leaves3.size(); i++) {
                UnitaryDiagram leaf = (UnitaryDiagram) leaves3.get(i);
                if (!(leaf instanceof FalseDiagram)) {
                    Vector contours = leaf.getContours();
                    Vector otherCs = (Vector) allContours.clone();
                    otherCs.removeAll((Vector)contours.clone());
                    contours.removeAll((Vector)otherCs.clone());
                    if (otherCs.size() > 0) {
                        Contour toAdd = (Contour) otherCs.get(0);
                        d =
                            RuleAddContour.getRule().applyRuleToPart(
                                d,
                                new RuleAppliesWithString(
                                    leaf,
                                    toAdd.toString()));
                        continue contourFormLoop;
                    }
                    if (otherCs.size() > 0) {
                        Contour toRemove = (Contour) otherCs.get(0);
                        d =
                            RuleDeleteContour.getRule().applyRuleToPart(
                                d,
                                new RuleAppliesToContour(
                                    leaf,
                                    toRemove));
                        continue contourFormLoop;
                    }
                }
            }
            break contourFormLoop;
        }
        contourFormLoop : while (true) {
            Vector leaves4 = context.getUnitaryParts();
            for (int i = 0; i < leaves4.size(); i++) {
                UnitaryDiagram leaf = (UnitaryDiagram) leaves4.get(i);
                if (!(leaf instanceof FalseDiagram)) {
                    Vector contours = leaf.getContours();
                    Vector otherCs = (Vector) allContours.clone();
                    otherCs.removeAll(contours);
                    if (otherCs.size() > 0) {
                        Contour toAdd = (Contour) otherCs.get(0);
                        context =
                            RuleAddContour.getRule().applyRuleToPart(
                                context,
                                new RuleAppliesWithString(
                                    leaf,
                                    toAdd.toString()));
                        continue contourFormLoop;
                    }
                }
            }
            break contourFormLoop;
        }

        // find universal set of zones

        // possibly this could just be all Venn zones instead of
        // those zones which are present somewhere

        Vector leaves5 = d.getUnitaryParts();
        Vector allZones = new Vector();
        for (int i = 0; i < leaves5.size(); i++) {
            UnitaryDiagram leaf = (UnitaryDiagram) leaves5.get(i);
            if (!(leaf instanceof FalseDiagram)) {
                Vector zones = leaf.getZones();
                for (int j = 0; j < zones.size(); j++) {
                    Zone z = (Zone) zones.get(j);
                    if (!allZones.contains(z)) {
                        allZones.add(z);
                    }
                }
            }
        }
        Vector leaves6 = context.getUnitaryParts();
        for (int i = 0; i < leaves6.size(); i++) {
            UnitaryDiagram leaf = (UnitaryDiagram) leaves6.get(i);
            if (!(leaf instanceof FalseDiagram)) {
                Vector zones = leaf.getZones();
                for (int j = 0; j < zones.size(); j++) {
                    Zone z = (Zone) zones.get(j);
                    if (!allZones.contains(z)) {
                        allZones.add(z);
                    }
                }
            }
        }
        return getMeasure(d, allZones, isMeasure1);
    }

    public static Vector getMeasure(
        Diagram d,
        //Vector universalSet,
        boolean isMeasure1) {

        boolean isDebug = false;

        if (isMeasure1) {
            if (isDebug) {
                System.out.print("finding Zone1 ");
            }
        } else {
            if (isDebug) {
                System.out.print("finding Zone2 ");
            }
        }
        if (isDebug) {
            System.out.println("diagram is " + d + " and U = " + universalSet);
        }

        if (d instanceof FalseDiagram) {
            if (isMeasure1) {
                if (isDebug) {
                    System.out.println(
                        "measure for " + d + " is " + universalSet);
                }
                return universalSet;
            } else {
                if (isDebug) {
                    System.out.println("measure for " + d + " is emptyset");
                }
                return new Vector();
            }
        } else if (d instanceof UnitaryDiagram) {
            Vector zones = ((UnitaryDiagram) d).getZones();
            if (isDebug) {
                System.out.println("measure for " + d + " is " + zones);
            }
            return zones;
        } else if (d instanceof NotCompoundDiagram) {
            Vector zones =
                getMeasure(
                    (Diagram) (((NotCompoundDiagram) d).getChildren().get(0)),
                    universalSet,
                    !isMeasure1);
            if (isDebug) {
                System.out.println("measure for " + d + " is " + zones);
            }
            return zones;

        } else if (d instanceof CompoundDiagram) {
            CompoundDiagram cd = (CompoundDiagram) d;
            Vector children = cd.getChildren();
            Vector measures = new Vector();
            for (int i = 0; i < children.size(); i++) {
                measures.add(
                    getMeasure(
                        (Diagram) (children.get(i)),
                        universalSet,
                        isMeasure1));
            }
            if (!isMeasure1
                && d instanceof AndCompoundDiagram
                || (isMeasure1 && d instanceof OrCompoundDiagram)) {
                // take intersection for C2
                if (isDebug) {
                    System.out.println("now take intersection");
                }
                Vector result = new Vector();
                Vector firstChildSet = (Vector) measures.get(0);
                for (int i = 0; i < firstChildSet.size(); i++) {
                    Zone z = (Zone) firstChildSet.get(i);
                    boolean isEverywhere = true;
                    for (int j = 1; j < measures.size(); j++) {
                        if (!((Vector) (measures.get(j))).contains(z)) {
                            isEverywhere = false;
                        }
                    }
                    if (isEverywhere) {
                        result.add(z);
                    }
                }
                if (isDebug) {
                    System.out.println("measure for " + d + " is " + result);
                }
                return result;
            } else {
                // take union for C1
                if (isDebug) {
                    System.out.println("now take union");
                }
                Vector result = new Vector();
                for (int j = 0; j < measures.size(); j++) {
                    Vector set = (Vector) measures.get(j);
                    for (int i = 0; i < set.size(); i++) {
                        Zone z = (Zone) set.get(i);
                        if (!result.contains(z)) {
                            result.add(z);
                        }
                    }
                }
                if (isDebug) {
                    System.out.println("measure for " + d + " is " + result);
                }
                return result;
            }
        }
        throw new IllegalArgumentException();
    }

    private static Vector z1Before, z1After, z2Before, z2After;
    private static Diagram start, end;
    private static boolean z1Unchanged() {
        return z1HasntGrown() && z1HasntShrunk();
    }
    private static boolean z2Unchanged() {
        return z2HasntGrown() && z2HasntShrunk();
    }
    private static boolean z1HasntGrown() {
        return z1Before.containsAll(z1After);
    }
    private static boolean z2HasntGrown() {
        return z2Before.containsAll(z2After);
    }
    private static boolean z1HasntShrunk() {
        return z1After.containsAll(z1Before);
    }
    private static boolean z2HasntShrunk() {
        return z2After.containsAll(z2Before);
    }
    private static boolean z1HasntChangedByMoreThanOne() {
        return Math.abs(z1After.size() - z1Before.size()) <= 1;
    }
    private static boolean z2HasntChangedByMoreThanOne() {
        return Math.abs(z2After.size() - z2Before.size()) <= 1;
    }

    private static void showreport(String message) {
        System.out.println(message);
        System.out.println(
            "start diagram is " + DiagramFileUser.toSaveString(start));
        System.out.println(
            "result diagram is " + DiagramFileUser.toSaveString(end));
        System.out.println("z1Before " + z1Before);
        System.out.println("z1After " + z1After);
        System.out.println("z2Before " + z2Before);
        System.out.println("z2After " + z2After);
    }

    public static void main(String args[]) {
        // build suitable rule set
        HashMap resultsHM = new HashMap();
        Vector HRules = HeuristicProofWriter.compoundHRules;
        Rule[] rules = new Rule[HRules.size()];
        for (int i = 0; i < HRules.size(); i++) {
            rules[i] = (Rule) HRules.get(i);
            resultsHM.put(rules[i].name, new Integer(0));
        }

        // build one-step proofs        
        ProofGetterRandom pgr1 = new ProofGetterRandom(2, 3, 2, 1, rules);
        ProofGetterRandom pgr2 = new ProofGetterRandom(1, 1, 2, 6, rules);
        ProofGetterRandom pgr3 = new ProofGetterRandom(0, 3, 2, 2, rules);

        // see how the measures change
        for (int i = 0; i < 500000; i++) {
            if (i % 10000 == 0) {
                System.out.println("" + i);
            }
            Proof p = null;
            if (i % 3 == 0) {
                p = pgr1.getProof(1);
            } else if (i % 3 == 1) {
                p = pgr2.getProof(1);
            } else {
                p = pgr3.getProof(1);
            }
            if (p.numSteps() == 0) {
                i--;
            } else {
                start = p.getFirstDiagram();
                end = p.getLastDiagram();
                z1Before = getMeasure(start, true, end);
                z2Before = getMeasure(start, false, end);
                z1After = getMeasure(end, true, start);
                z2After = getMeasure(end, false, start);
                Rule r = p.getImminentRule();
                // log which rules we have experienced
                resultsHM.put(
                    r.name,
                    new Integer(
                        ((Integer) (resultsHM.get(r.name))).intValue() + 1));
                // by default we expect the measure to be left unchanged
                if (z1Unchanged() && z2Unchanged()) {
                } else if (r instanceof RuleIntroduceShadedZone) {
                    if (z1HasntShrunk()
                        && z1HasntChangedByMoreThanOne()
                        && z2HasntShrunk()
                        && z2HasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof RuleDeleteShadedZone) {
                    if (z1HasntGrown()
                        && z1HasntChangedByMoreThanOne()
                        && z2HasntGrown()
                        && z2HasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof MergeContradictionRule) {
                    if (   z1HasntGrown()
                        && z2HasntGrown()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof NotTrueIsFalseRule) {
                    if (   z1HasntChangedByMoreThanOne()) {
                    } else {
                        showreport("" + r);
                    }
                } else if (r instanceof NotFalseIsTrueRule) {
                    if (   z1HasntShrunk()
                    ) {
                    } else {
                        showreport("" + r);
                    }
                } else {
                    showreport(" unexpected change : "+r);
                }
            }
        }
        System.out.println("");
        for (int i = 0; i < HRules.size(); i++) {
            Rule r = (Rule) HRules.get(i);
            System.out.println("" + resultsHM.get(r.name) + " " + r.name);
        }
    }
    */
}
