package rwd.rules.inputspec;
import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.Diagram;
//import rwd.abstractsyntax.spiderdiagram.DiagramFileUser;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.application.RuleAppliesToDiagramAndDiagram;
import rwd.abstractsyntax.spiderdiagram.OrCompoundDiagram;
import java.util.Vector;

public class RulePToPand_PorQ extends RuleNeedsInput {
	private RulePToPand_PorQ() {
		super("P->P and (P or Q)");
	}
	private static Rule example = null;

	public static Rule getRule() {
		if (example == null) {
			example = new RulePToPand_PorQ();
		}
		return example;
	}
    public boolean isInvertible(){
        return true;
    }    

	public Class getInputType() {
		try {
			return Class.forName("rwd.abstractsyntax.spiderdiagram.Diagram");
		} catch (ClassNotFoundException x) {
			System.out.println("Diagram class not found for RulePToPOrRubbish");
			return null;
		}
	}
	public boolean canApplyTo(Diagram d) {
		return true;
	}

	public Diagram applyRule(RuleApplicationSpec r) {
		Diagram other = null;
		try {
			other = ((RuleAppliesToDiagramAndDiagram) r).other;
		} catch (ClassCastException e) {
			System.out.println("spec wasn't right in RulePToPandPorQ");
			return null;
		}
		Vector diagrams = new Vector();
		diagrams.add(r.d);
		diagrams.add(other);
        //System.out.print("~~~~~~~~~~~~~~~~~~~~~~~~~~");
        //System.out.print("in Rulep->POrQ one part is "+DiagramFileUser.toSaveString(r.d));
        //System.out.print("in Rulep->POrQ another part is "+DiagramFileUser.toSaveString(other));
        Diagram result = new AndCompoundDiagram(diagrams, "andcd");
        //System.out.print("in Rulep->POrQ combination is ");
        //String text = DiagramFileUser.toSaveString(result);
		//System.out.println(text);
        diagrams = new Vector();
        diagrams.add(result);
        diagrams.add(r.d);
        result = new OrCompoundDiagram(diagrams,"orCD");
        return result;
	}
}
