package rwd.rules.nospec;

import rwd.abstractsyntax.spiderdiagram.CompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.abstractsyntax.spiderdiagram.FalseDiagram;
import rwd.abstractsyntax.spiderdiagram.NotCompoundDiagram;
import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;

public class NotTrueIsFalseRule extends RuleNoSpec {
    private NotTrueIsFalseRule() {
        super("sd: Not(True) is False");
    }
    private static Rule example = null;

    public static Rule getRule() {
        if (example == null) {
            example = new NotTrueIsFalseRule();
        }
        return example;
    }
    public boolean isInvertible() {
        return true;
    }

    public boolean canApplyTo(Diagram d) {
        if (!(d instanceof NotCompoundDiagram)) {
            return false;
        } else {
            Diagram child =
                (Diagram) (((NotCompoundDiagram) d).getChildren().get(0));
            if (child instanceof FalseDiagram
                || child instanceof CompoundDiagram) {
                return false;
            } else {
                UnitaryDiagram ud = ((UnitaryDiagram) child);
                if (ud.getCloneOfContourSet().size() > 0) {
                    return false;
                } else if (ud.getNumShadedZones() > 0) {
                    return false;
                } else if (ud.getSpiders().size() > 0) {
                    return false;
                } else {
                    return true;
                }
            }
        }
    }
    public Diagram applyRule(RuleApplicationSpec r) {
        return new FalseDiagram("f");
    }
}
