package rwd.rules.nospec;

import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
import rwd.rules.application.RuleAppliesToJustADiagram;
import java.util.Vector;

import rwd.rules.choicespec.RuleDMPushNotThroughAnd;
import rwd.rules.choicespec.RuleDMPushNotThroughOr;
import rwd.rules.choicespec.RuleWithChoice;

public class RulePushNotsToLeaves extends RuleNoSpec {
    public RulePushNotsToLeaves() {
        super("sd: push nots to leaves");
    }
    private static Rule example = null;

    public static Rule getRule() {
        if (example == null) {
            example = new RulePushNotsToLeaves();
        }
        return example;
    }
    public boolean isInvertible() {
        return true;
    }

    public boolean canApplyTo(Diagram d) {
        return true;
    }

    public Diagram applyRule(RuleApplicationSpec r) {
        RuleAppliesToJustADiagram rajd = (RuleAppliesToJustADiagram) r;
        Diagram d = rajd.d;

        RuleWithChoice rwc1 =
            (RuleWithChoice) RuleDMPushNotThroughAnd.getRule();
        RuleWithChoice rwc2 = (RuleWithChoice) RuleDMPushNotThroughOr.getRule();
        Rule rnnr = RemoveNotNotRule.getRule();
        boolean hasChanged = true;
        partLoop : while (hasChanged) {
            hasChanged = false;
            Diagram part = rnnr.findApplicablePart(d);
            if (part != null) {
                RuleApplicationSpec spec = new RuleAppliesToJustADiagram(part);
                d = rnnr.applyRuleToPart(d, spec);
                //System.out.println("apply rnnr");
                hasChanged = true;
            }
            part = rwc1.findApplicablePart(d);
            if (part != null) {
                Vector specs = rwc1.getApplicationPossibilities(part);
                RuleApplicationSpec spec = (RuleApplicationSpec) specs.get(0);
                d = rwc1.applyRuleToPart(d, spec);
                //System.out.println("apply rwc1 with spec "+spec);
                hasChanged = true;
            }
            part = rwc2.findApplicablePart(d);
            if (part != null) {
                Vector specs = rwc2.getApplicationPossibilities(part);
                RuleApplicationSpec spec = (RuleApplicationSpec) specs.get(0);
                d = rwc2.applyRuleToPart(d, spec);
                //System.out.println("apply rwc2 with spec "+spec);
                //System.out.println("d is now "+DiagramFileUser.toSaveString(d));                
                hasChanged = true;
            }
        }
        return d;
    }
}
