package rwd.rules.nospec;
//import rwd.abstractsyntax.eulerdiagram.Zone;
import rwd.abstractsyntax.spiderdiagram.Diagram;
import rwd.rules.Rule;
import rwd.rules.application.RuleApplicationSpec;
//import rwd.rules.application.RuleAppliesToJustADiagram;
import rwd.rules.choicespec.MergeConjunctionRule;
import rwd.rules.choicespec.MergeContradictionRule;
import rwd.rules.choicespec.RuleWithChoice;
import rwd.rules.choicespec.TrueWithAndRule;
//import rwd.abstractsyntax.spiderdiagram.AndCompoundDiagram;
//import java.util.Vector;
//import rwd.abstractsyntax.spiderdiagram.UnitaryDiagram;
//import rwd.abstractsyntax.spiderdiagram.Spider;
//import rwd.abstractsyntax.spiderdiagram.FalseDiagram;

public class SimpleCombiningRule extends RuleNoSpec {
    private SimpleCombiningRule() {
        super("sd: combine");
    }

    private static Rule example = null;

    public static Rule getRule() {
        if (example == null) {
            example = new SimpleCombiningRule();
        }
        return example;
    }
    public boolean isInvertible() {
        return true;
    }

    public boolean canApplyTo(Diagram d) { // d must be an And-Diagram, look at its children
        // they must all be unitary
        // check they all have matching contour sets
        // check they all are alpha-diagrams
        /*		try {
        			if (d instanceof AndCompoundDiagram) {
        				AndCompoundDiagram acd = (AndCompoundDiagram) d;
        				Vector children = acd.getChildren();
        				UnitaryDiagram d0 = (UnitaryDiagram) (children.get(0));
        				Vector spiders = d0.getSpiders();
        				for (int i = 0; i < spiders.size(); i++) {
        					Spider s = (Spider) spiders.get(i);
        					if (s.getHabitat().size() > 1) {
        						return false;
        					}
        				}
        				Vector contours0 = d0.getContours();
        				Vector zones0 = d0.getZones();
        				for (int i = 1; i < children.size(); i++) {
        					UnitaryDiagram dother = (UnitaryDiagram) (children.get(i));
        					Vector contoursOther = dother.getContours();
        					if (!(contours0.containsAll(contoursOther)
        						&& contoursOther.containsAll(contours0))) {
        						return false;
        					}
        					Vector zonesOther = dother.getZones();
        					if (!(zones0.containsAll(zonesOther)
        						&& zonesOther.containsAll(zones0))) {
        						return false;
        					}
        					spiders = dother.getSpiders();
        					for (int j = 0; j < spiders.size(); j++) {
        						Spider s = (Spider) spiders.get(j);
        						if (s.getHabitat().size() > 1) {
        							return false;
        						}
        					}
        				}
        				return true;
        			} else {
        				return false;
        			}
        		} catch (Exception e) {
        			return false;
        		}
                */
        return MergeConjunctionRule.getRule().canApplyTo(d)
            || MergeContradictionRule.getRule().canApplyTo(d);
    }

    public Diagram applyRule(RuleApplicationSpec r) { //System.out.println("about to apply Simple combining rwd.rules to "+r.d.toSaveString());
        /*		RuleAppliesToJustADiagram rajd = (RuleAppliesToJustADiagram) r;
        		AndCompoundDiagram d = (AndCompoundDiagram) rajd.d;
        		Vector children = d.getChildren();
        		UnitaryDiagram ud0 = (UnitaryDiagram) children.get(0);
        		if (ud0 instanceof FalseDiagram) {
        			return new FalseDiagram("f");
        		}
        		Vector contours = ud0.getContours();
        		// find the venn set of zones
        		Vector vennZones = UnitaryDiagram.allPossibleZones(contours);
        		// find max#spiders touching each of venn-zones
        		int[] maxNum = new int[vennZones.size()];
        		for (int i = 0; i < maxNum.length; i++) {
        			maxNum[i] = 0;
        		}
        		int[][] numInZone = new int[children.size()][vennZones.size()];
        		for (int i = 0; i < children.size(); i++) {
        			UnitaryDiagram ud = (UnitaryDiagram) children.get(i);
        			if (ud instanceof FalseDiagram) {
        				return new FalseDiagram("f");
        			}
        			Vector spiders = ud.getSpiders();
        			for (int j = 0; j < vennZones.size(); j++) {
        				Zone vennz = (Zone) vennZones.get(j);
        				numInZone[i][j] = 0;
        				for (int k = 0; k < spiders.size(); k++) {
        					Spider s = (Spider) spiders.get(k);
        					if (s.getHabitat().contains(vennz)) {
        						numInZone[i][j]++;
        					}
        				}
        			}
        		}
        		for (int i = 0; i < children.size(); i++) {
        			for (int j = 0; j < vennZones.size(); j++) {
        				if (numInZone[i][j] > maxNum[j]) {
        					maxNum[j] = numInZone[i][j];
        				}
        			}
        		}
        		// check that in a component, if #touching < max#
        		for (int i = 0; i < children.size(); i++) {
        			for (int j = 0; j < vennZones.size(); j++) {
        				if (numInZone[i][j] < maxNum[j]) {
        					// find out whether the zone in ud is present, unshaded
        					UnitaryDiagram ud = (UnitaryDiagram) children.get(i);
        					Zone z = (Zone) vennZones.get(j);
        					if (!(ud.getZones().contains(z)
        						&& !ud.containsShaded(z))) {
        						return new FalseDiagram("false");
        					}
        				}
        			}
        		} 
        		boolean[] isAZone = new boolean[vennZones.size()];
        		// will be set "true" as zones are found in children
        		boolean[] isAnAbsentZone = new boolean[vennZones.size()];
        		// will be set "true" as zones are absent in children
        		boolean[] isAShadedZone = new boolean[vennZones.size()];
        		// will be set "true" as zones are shaded in children
        		for (int i = 0; i < vennZones.size(); i++) {
        			isAZone[i] = false;
        			isAnAbsentZone[i] = false;
        			isAShadedZone[i] = false;
        		}
        		// build union of present zones,
        		for (int i = 0; i < children.size(); i++) {
        			UnitaryDiagram child = (UnitaryDiagram) children.get(i);
        			for (int j = 0; j < vennZones.size(); j++) {
        				Zone z = (Zone) vennZones.get(j);
        				if (child.getZones().contains(z)) {
        					isAZone[j] = true;
        				} else {
        					isAnAbsentZone[j] = true;
        				}
        				if (child.containsShaded(z)) {
        					isAShadedZone[j] = true;
        				}
        			}
        		}
        		// if a zone was present somewhere and absent somewhere, make it shaded
        		for (int i = 0; i < vennZones.size(); i++) {
        			if (isAZone[i] && isAnAbsentZone[i]) {
        				isAShadedZone[i] = true;
        			}
        		}
        		Vector resultingZones = new Vector();
        		Vector shadedZones = new Vector();
        		for (int i = 0; i < vennZones.size(); i++) {
        			if (isAZone[i]) {
        				resultingZones.add(vennZones.get(i));
        			}
        			if (isAShadedZone[i]) {
        				shadedZones.add(vennZones.get(i));
        			}
        		}
        		// add max# spiders
        		UnitaryDiagram result = new UnitaryDiagram(resultingZones, "outcome");
        		result.shadeRegion(shadedZones);
        		for (int i = 0; i < maxNum.length; i++) {
        			Zone z = (Zone) vennZones.get(i);
        			Vector habitat = new Vector();
        			habitat.add(z);
        			for (int j = 0; j < maxNum[i]; j++) {
        				result.addSpider(habitat);
        			}
        		}
        		return result;*/
        Diagram d = r.d;
        boolean hasChanged= true;
        while(hasChanged){
            hasChanged = false;
            while (MergeConjunctionRule.getRule().canApplyTo(d)) {
                RuleApplicationSpec ras =
                    (RuleApplicationSpec) ((RuleWithChoice) MergeConjunctionRule
                        .getRule())
                        .getApplicationPossibilities(d)
                        .get(0);
                d = MergeConjunctionRule.getRule().applyRule(ras);
                hasChanged = true;
            }
            while (MergeContradictionRule.getRule().canApplyTo(d)) {
                RuleApplicationSpec ras =
                    (RuleApplicationSpec) ((RuleWithChoice) MergeContradictionRule
                        .getRule())
                        .getApplicationPossibilities(d)
                        .get(0);
                d = MergeContradictionRule.getRule().applyRule(ras);
                hasChanged = true;
            }
            while (TrueWithAndRule.getRule().canApplyTo(d)) {
                RuleApplicationSpec ras =
                    (RuleApplicationSpec) ((RuleWithChoice) TrueWithAndRule
                        .getRule())
                        .getApplicationPossibilities(d)
                        .get(0);
                d = TrueWithAndRule.getRule().applyRule(ras);
                hasChanged = true;
            }
        }
        return d;
    }
}
