package rwd.tableaux.semantic;

import java.awt.Dimension;
import java.util.*;

import javax.swing.*;

import uk.ac.kent.cs.kmf.util.*;

/**
 * @author Octavian Patrascoiu
 *
 */
public class TableauViewerImpl 
	extends JInternalFrame 
{
	public TableauViewerImpl(JDesktopPane desktop) {
		init(desktop, 640, 480);
	}
	public TableauViewerImpl(JDesktopPane desktop, int width, int height) {
		init(desktop, width, height);
	}
	protected void init (JDesktopPane desktop, int width, int height) {
		this.desktop = desktop;
		this.setSize(new Dimension(width, height));
		this.setTitle("Tableau");
		this.setClosable(true);
		this.setIconifiable(true);
		this.setMaximizable(true);
		this.setResizable(true);
	}
	public void view(String strExp, Options opt, List diags, ILog log) {
		view(strExp, opt, diags, opt.getDiagramSize(), log);
	}
	public void view(String strExp, Options opt, List diags, int diagramSize, ILog log) {
		this.diags = diags;
		this.log = log;
		ETableau t = new ETableauImpl(desktop, log);
		JTree tree = t.build(strExp, opt, diags);
		view(tree);
	}
	public void viewExpandable(String strExp, Options opt, List diags, ILog log) {
		viewExpandable(strExp, opt, diags, opt.getDiagramSize(), log);
	}
	public void viewExpandable(String strExp, Options opt, List diags, int diagramSize, ILog log) {
		this.diags = diags;
		this.log = log;
		ETableau t = new ETableauImpl(desktop, log);
		JTree tree = t.build(strExp, opt, diags);
		if (tree != null)
			view((JTree)tree);
	}
	public void view(JTree tree) {
		if (tree == null) {
			this.dispose();
		} else {
			JScrollPane treeScroll = new JScrollPane();
			treeScroll.getViewport().add(tree);
			this.getContentPane().add(treeScroll);
			this.setVisible(true);
		}
	}

	private JTree tree = new JTree();
	private List diags = new Vector();
	private ILog log = new ConsoleLog();
	private JDesktopPane desktop;
}
