package rwd.tableaux.syntax.ast;

/**
 * @author Octavian Patrascoiu
 *
 */
public class AstFactoryImpl
	implements AstFactory 
{
	public LogicalExp buildAtomicExp(String name, Object loc) {
		AtomicExp result = new AtomicExp$Class();
		result.setValue(name);
		result.setLoc(loc);
		return result;
	}
	public LogicalExp buildNotExp(LogicalExp left, Object loc) {
		NotExp result = new NotExp$Class();
		result.setLeft(left);
		result.setLoc(loc);
		return result;
	}
	public LogicalExp buildAndExp(LogicalExp left, LogicalExp right, Object loc) {
		AndExp result = new AndExp$Class();
		result.setLeft(left);
		result.setRight(right);
		result.setLoc(loc);
		return result;
	}
	public LogicalExp buildOrExp(LogicalExp left, LogicalExp right, Object loc) {
		OrExp result = new OrExp$Class();
		result.setLeft(left);
		result.setRight(right);
		result.setLoc(loc);
		return result;
	}
	public LogicalExp buildImpliesExp(LogicalExp left, LogicalExp right, Object loc) {
		ImpliesExp result = new ImpliesExp$Class();
		result.setLeft(left);
		result.setRight(right);
		result.setLoc(loc);
		return result;
	}
	public LogicalExp buildEquivalentExp(LogicalExp left, LogicalExp right, Object loc) {
		EquivalentExp result = new EquivalentExp$Class();
		result.setLeft(left);
		result.setRight(right);
		result.setLoc(loc);
		return result;
	}
}
