package rwd.gui.editor.listeners.diagramcontrollers;

import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

//import rwd.concretesyntax.DiagramItem;
//import rwd.concretesyntax.spiderdiagram.ConcreteSpiderFoot;
//import rwd.gui.editor.DiagramCanvas;

/**
 * The default state class for a diagram controller.
 * State classes should override methods of interest in this class.
 *  
 * @author Richard Bosworth
 * 
 * @version 20-Apr-2005 10:55
 */
public class StateDefault
	implements DiagramControllerState
{
	private DiagramController myContext;
	
	private float _previousX;
	private float _previousY;
		
	
	// constructor
	// -----------
	
	/**
	 * Post: new StateDefault object has been constructed with the specified context
	 * @param dc = context for this state
	 */
	/*
	 * test: once thru
	 */
	public StateDefault(DiagramController dc)
	{
		myContext = dc;
	}
	
    // operations
	// ----------
	
	// mouse events
	// ------------
	
	/**
	 * @see DiagramControllerState#mouseClicked(java.awt.event.MouseEvent)
	 */
	public void mouseClicked(MouseEvent e) 
	{
		System.out.println("StateDefault.mouseClicked");
		System.out.println("e.paramString()="+e.paramString()+ "\n");
	}
	
	/**
	 * @see DiagramControllerState#mousePressed(java.awt.event.MouseEvent)
	 */
	public synchronized void mousePressed(MouseEvent e) 
	{
		System.out.println("StateDefault.mousePressed");
		System.out.println("e.paramString()="+e.paramString()+ "\n");
	}


	
	/**
	 * @see DiagramControllerState#mouseReleased(java.awt.event.MouseEvent)
	 */
	public void mouseReleased(MouseEvent e)
	{
		System.out.println("StateDefault.mouseReleased\n");
		System.out.println("e.paramString()="+e.paramString()+ "\n");
	}
	
	/**
	 * @see DiagramControllerState#mouseEntered(java.awt.event.MouseEvent)
	 */
	public void mouseEntered(MouseEvent e)
	{
		System.out.println("StateDefault.mouseEntered");
		System.out.println("e.paramString()="+e.paramString()+ "\n");
	}
	
	/**
	 * @see DiagramControllerState#mouseExited(java.awt.event.MouseEvent)
	 */
	public void mouseExited(MouseEvent e)
	{
		System.out.println("StateDefault.mouseExited");
		System.out.println("e.paramString()="+e.paramString()+ "\n");
	}
	
	/**
	 * @see DiagramControllerState#mouseDragged(java.awt.event.MouseEvent)
	 */
	public void mouseDragged(MouseEvent e)
	{
		System.out.println("StateDefault.mouseDragged");
		System.out.println("e.paramString()="+e.paramString()+ "\n");
	}
	
	/**
	 * @see DiagramControllerState#mouseMoved(java.awt.event.MouseEvent)
	 */
	public void mouseMoved(MouseEvent e)
	{
		System.out.println("StateDefault.mouseMoved");
		System.out.println("e.paramString()="+e.paramString()+ "\n");
	}

	/**
	 * @see DiagramControllerState#keyTyped(java.awt.event.KeyEvent)
	 */
	public void keyTyped(KeyEvent e)
	{
		System.out.println("StateDefault.keyTyped");
		System.out.println("e.paramString()="+e.paramString()+ "\n");
	}
	
	/**
	 * @see DiagramControllerState#keyPressed(java.awt.event.KeyEvent)
	 */
	public void keyPressed(KeyEvent e)
	{
		System.out.println("StateDefault.keyPressed");
		System.out.println("e.paramString()="+e.paramString()+ "\n");
	}
	
	/**
	 * @see DiagramControllerState#keyReleased(java.awt.event.KeyEvent)
	 */
	public void keyReleased(KeyEvent e)
	{
		System.out.println("StateDefault.keyReleased");
		System.out.println("e.paramString()="+e.paramString()+ "\n");
	}
}
